
# This procedure average chemical shifts from peak lists and reports assignment errors
# Written by Pascal Mercier
# March 7, 2000
# the function argmuments are peak lists
# this routine needs the Hasting distribution of nmrview


proc fillshifts {} {

global Nv_Natoms

# first check if there is a sequence loaded in memory
if {$Nv_Natoms==0} {
	bell
	puts "Prior to using this program you need to have a sequence loaded"
	return
	}

if {![winfo exists .fillshifts]} {
       makefillshiftsavg
    } else {
     wm deiconify .fillshifts
    }
}



proc makefillshiftsavg {} {

set base .fillshifts

    toplevel $base -class Toplevel \
        -menu $base.m40 
    wm focusmodel $base passive
    wm geometry $base 409x431+130+177
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Averaging of Chemical Shifts"
    label $base.lab19 \
        -borderwidth 0  -text {Available peak lists} -font {Helvetica -12}
    button $base.but21 \
         -activebackground #fe3640 -padx 11 -pady 4 -text "Add->" -font {Helvetica -12} -command {AddSelection}
    button $base.but22 \
         -activebackground #fe3640 -padx 11 -pady 4 -text "<-Remove" -font {Helvetica -12} -command {DeleteSelection} 
    label $base.lab27 \
        -borderwidth 1  -text {Peak lists used} -font {Helvetica -12}
    button $base.but28 \
        -activebackground #fe3640  -padx 11 -pady 4 -text Proceed -font {Helvetica -12 bold} -command {doshiftaveraging}
    button $base.but29 \
        -activebackground #fe3640  -padx 11 -pady 4 -text Quit -font {Helvetica -12 bold} -command {destroy .fillshifts}
    label $base.lab34 \
        -borderwidth 1  -font {Helvetica -10} -justify left \
        -text {Written by Pascal Mercier
March 7, 2000
University of Alberta
Brian Sykes lab} 
    label $base.lab37 \
        -borderwidth 1  -text {Tolerance settings} -font {Helvetica -12 bold}
    frame $base.cpd39 \
        -borderwidth 1  -height 30 -relief raised -width 30 
    label $base.cpd39.01 \
        -anchor w  -relief groove -text H -font {Helvetica -12}
    entry $base.cpd39.02 \
         -highlightthickness 0 -font {Helvetica -12} -textvariable protontolerance \
         -width 0 
    frame $base.cpd39.fra41 \
        -borderwidth 1  -height 30 -relief raised -width 30 
    label $base.cpd39.fra41.01 \
        -anchor w  -relief groove -text H -font {Helvetica -12}
    entry $base.cpd39.fra41.02 \
         -highlightthickness 0  -width 0 
    frame $base.cpd39.fra42 \
        -borderwidth 1  -height 30 -relief raised -width 30 
    label $base.cpd39.fra42.01 \
        -anchor w  -relief groove -text H -font {Helvetica -12}
    entry $base.cpd39.fra42.02 \
         -highlightthickness 0  -width 0 
    frame $base.cpd39.fra42.03 \
        -borderwidth 1  -height 30 -relief raised -width 30 
    label $base.cpd39.fra42.03.04 \
        -anchor w  -relief groove -text H -font {Helvetica -12}
    frame $base.cpd39.cpd44 \
        -borderwidth 1 -height 30 -relief raised -width 30 
    label $base.cpd39.cpd44.01 \
        -anchor w -relief groove -text label -font {Helvetica -12}
    entry $base.cpd39.cpd44.02 \
        -cursor {} -highlightthickness 0  
    menu $base.m40 \
        -cursor {} 
    frame $base.cpd43 \
        -borderwidth 1  -height 30 -relief raised -width 30 
    label $base.cpd43.01 \
        -anchor w  -relief groove -text N -font {Helvetica -12}
    entry $base.cpd43.02 \
         -highlightthickness 0 -textvariable nitrogentolerance -font {Helvetica -12}\
         
    frame $base.cpd46 \
        -borderwidth 1  -height 30 -relief raised -width 30 
    label $base.cpd46.01 \
        -anchor w  -relief groove -text C -font {Helvetica -12}
    entry $base.cpd46.02 \
        -cursor {} -highlightthickness 0 -textvariable carbontolerance -font {Helvetica -12}\
         
    frame $base.cpd47 \
        -borderwidth 1  -height 30 -relief raised -width 30 
    listbox $base.cpd47.01 \
         \
        -font {Helvetica -12} \
        -xscrollcommand {.fillshifts.cpd47.02 set} \
        -yscrollcommand {.fillshifts.cpd47.03 set} 
    scrollbar $base.cpd47.02 \
        -borderwidth 1 -command {.fillshifts.cpd47.01 xview} -orient horizontal \
        -width 10 
    scrollbar $base.cpd47.03 \
        -borderwidth 1 -command {.fillshifts.cpd47.01 yview}  \
        -width 10 
    frame $base.cpd48 \
        -borderwidth 1  -height 30 -relief raised -width 30 
    listbox $base.cpd48.01 \
        -font {Helvetica -12} \
        -xscrollcommand {.fillshifts.cpd48.02 set} \
        -yscrollcommand {.fillshifts.cpd48.03 set} 
    scrollbar $base.cpd48.02 \
        -borderwidth 1 -command {.fillshifts.cpd48.01 xview} -orient horizontal \
        -width 10 
    scrollbar $base.cpd48.03 \
        -borderwidth 1 -command {.fillshifts.cpd48.01 yview} -width 10 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.lab19 \
        -x 15 -y 5 -anchor nw -bordermode ignore 
    place $base.but21 \
        -x 162 -y 55 -width 80 -height 28 -anchor nw -bordermode ignore 
    place $base.but22 \
        -x 162 -y 95 -width 80 -height 28 -anchor nw -bordermode ignore 
    place $base.lab27 \
        -x 251 -y 5 -width 114 -height 18 -anchor nw -bordermode ignore 
    place $base.but28 \
        -x 5 -y 330 -width 131 -height 28 -anchor nw -bordermode ignore 
    place $base.but29 \
        -x 145 -y 330 -width 131 -height 28 -anchor nw -bordermode ignore 
    place $base.lab34 \
        -x 10 -y 370 -anchor nw -bordermode ignore 
    place $base.lab37 \
        -x 11 -y 185 -width 107 -height 18 -anchor nw -bordermode ignore 
    place $base.cpd39 \
        -x 10 -y 210 -width 65 -height 25 -anchor nw -bordermode ignore 
    pack $base.cpd39.01 \
        -in $base.cpd39 -anchor center -expand 0 -fill none -padx 2 -pady 2 \
        -side left 
    pack $base.cpd39.02 \
        -in $base.cpd39 -anchor center -expand 1 -fill x -padx 2 -pady 2 \
        -side right 
    place $base.cpd39.fra41 \
        -x 10 -y 209 -width 110 -height 25 -anchor nw -bordermode ignore 
    pack $base.cpd39.fra41.01 \
        -in $base.cpd39.fra41 -anchor center -expand 0 -fill none -padx 2 \
        -pady 2 -side left 
    pack $base.cpd39.fra41.02 \
        -in $base.cpd39.fra41 -anchor center -expand 1 -fill x -padx 2 \
        -pady 2 -side right 
    place $base.cpd39.fra42 \
        -x 10 -y 210 -width 110 -height 25 -anchor nw -bordermode ignore 
    pack $base.cpd39.fra42.01 \
        -in $base.cpd39.fra42 -anchor center -expand 0 -fill none -padx 2 \
        -pady 2 -side left 
    pack $base.cpd39.fra42.02 \
        -in $base.cpd39.fra42 -anchor center -expand 1 -fill x -padx 2 \
        -pady 2 -side right 
    place $base.cpd39.fra42.03 \
        -x 10 -y 209 -width 110 -height 25 -anchor nw -bordermode ignore 
    place $base.cpd39.cpd44 \
        -x 145 -y 50 -width 245 -height 25 -anchor nw -bordermode ignore 
    pack $base.cpd39.cpd44.01 \
        -in $base.cpd39.cpd44 -anchor center -expand 0 -fill none -padx 2 \
        -pady 2 -side left 
    pack $base.cpd39.cpd44.02 \
        -in $base.cpd39.cpd44 -anchor center -expand 1 -fill x -padx 2 \
        -pady 2 -side right 
    place $base.cpd43 \
        -x 10 -y 240 -width 65 -height 25 -anchor nw -bordermode ignore 
    pack $base.cpd43.01 \
        -in $base.cpd43 -anchor center -expand 0 -fill none -padx 2 -pady 2 \
        -side left 
    pack $base.cpd43.02 \
        -in $base.cpd43 -anchor center -expand 1 -fill x -padx 2 -pady 2 \
        -side right 
    place $base.cpd46 \
        -x 10 -y 270 -width 65 -height 30 -anchor nw -bordermode ignore 
    pack $base.cpd46.01 \
        -in $base.cpd46 -anchor center -expand 0 -fill none -padx 2 -pady 2 \
        -side left 
    pack $base.cpd46.02 \
        -in $base.cpd46 -anchor center -expand 1 -fill x -padx 2 -pady 2 \
        -side right 
    place $base.cpd47 \
        -x 10 -y 30 -width 145 -height 145 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd47 0 -weight 1
    grid rowconf $base.cpd47 0 -weight 1
    grid $base.cpd47.01 \
        -in $base.cpd47 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd47.02 \
        -in $base.cpd47 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd47.03 \
        -in $base.cpd47 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.cpd48 \
        -x 250 -y 30 -width 145 -height 145 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd48 0 -weight 1
    grid rowconf $base.cpd48 0 -weight 1
    grid $base.cpd48.01 \
        -in $base.cpd48 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd48.02 \
        -in $base.cpd48 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd48.03 \
        -in $base.cpd48 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 

bind .fillshifts.cpd47.01 <Double-1> {
	AddSelection
}

bind .fillshifts.cpd48.01 <Double-1> {
	DeleteSelection
}

# Clear each lists
.fillshifts.cpd47.01 delete 0 end
.fillshifts.cpd48.01 delete 0 end

#insert the list of available peak lists in the first list
foreach list [nv_peak list] { .fillshifts.cpd47.01 insert end $list}
}

#set default tolerance value
set protontolerance 0.05
set nitrogentolerance 0.2
set carbontolerance 0.3

proc AddSelection {} {
	if {[selection own]==".fillshifts.cpd47.01"} {
   		.fillshifts.cpd48.01 insert end [selection get]
   		.fillshifts.cpd47.01 delete active
	}
}

proc DeleteSelection {} {
	if {[selection own]==".fillshifts.cpd48.01"} {
   		.fillshifts.cpd47.01 insert end [selection get]
   		.fillshifts.cpd48.01 delete active
	}
}





########################################
#
# This is where the fun begins
#
########################################

proc doshiftaveraging {} {

global nitrogentolerance carbontolerance protontolerance

# check if the user has chosen at least one peak list to work with
if {[.fillshifts.cpd48.01 size]==0} {
	bell
	puts "Hey bozo, I'm not fully idiot-prof but I detected you did not select any peak list to work with.  Before you chose at least one I can't be of any help."
return
}

# check if the user has tolerance values for H, N and C
set protontolerance    [.fillshifts.cpd39.02 get]
set nitrogrentolerance [.fillshifts.cpd43.02 get]
set carbontolerance    [.fillshifts.cpd46.02 get]

if {$protontolerance<0 || $nitrogrentolerance<0 || $carbontolerance<0} {
	bell
	puts "For the program to work you need to set tolerance values for proton, nitrogen and carbon atoms.  One of them is not set, or one of them is set to a negative value"
}

###########################################
# core of the procedure
###########################################

global amino
global chemicalshift
global Nv_Natoms
set numberatoms $Nv_Natoms

# store all the peak lists chosen in a variable called allpeaklist
set allpeaklist [.fillshifts.cpd48.01 get 0 end]

puts "getting mean chemical shifts from BMRB"
  if {![info exists amino]} then {
	# the GetAminoTables is from the Hasting dribution of nmrview (script resdata.tcl)
        GetAminoTables
    }

puts "starting anaylsis... please be patient"; puts ""

# if the report window does not exist, make it, and if it does exists, clear the the list boxes

if {![winfo exists .report]} {
       makereportfillshifts
    } else {
     .report.cpd24.01 delete 0 end
     .report.cpd28.01 delete 0 end
}


# First extract chemical shifts for all atoms and store the results in a matrix called chemicalshift
# The matrix will have the following form:
# chemicalshift(i) hsqc.2 118.5 tocsy.5 118.25 etc
# where i is the atom number, hsqc and tocsy were two peak lists used and 2 and 5 are peak numbers 
# in the hsqc and tocsy list whose labels contain atom i.

for {set i 0} {$i<=$numberatoms} {incr i 1} {
	set resname   [nv_atom elem rname $i]
	set resnumber [nv_atom elem seq   $i]
	set atomname  [nv_atom elem aname $i]
	set searchfor $resnumber.$atomname
	set hit ""

	

	foreach peaklist $allpeaklist {

	set labels [nv_peak label $peaklist]

	# extract the peaks that are labeled what the program is looking for
	set matches [nv_peak match $peaklist $searchfor]

		foreach peakmatch $matches {
		# extract the peak number correctly
		set peaknumber [string trimleft $peakmatch $peaklist]
		set peaknumber [string trimleft $peaknumber .]
		set dimindex 0
		# check which dimension is labelled what the program is looking for
		
			foreach dimension $labels {
			 if {[nv_peak elem $dimension.L $peaklist.$peaknumber]==$searchfor} {
				# if the program was looking for an C atom, the chemical shift might need folding
# FOLLOWING COMMENTED BY SMG
#				if {[string range $atomname 0 0]=="C"} {
##	puts "$labels dimindex:$dimindex  $dimension it's a C atom  peaknumber is $peaknumber"
#				set currentppm [nv_peak elem $dimension.P $peaklist.$peaknumber]
#				set sw [lindex [nv_peak sw $peaklist] $dimindex]
#				set sf [lindex [nv_peak sf $peaklist] $dimindex]
#				set currentppmup [expr $currentppm + $sw/$sf]
#				set currentppmdown [expr $currentppm - $sw/$sf]
#				set expectedppm  $amino($resname,$atomname,shift)
#				# assign one of the 3 possible chemical shifts to the one that's closer to the expected value
#				set difference     [expr abs ($currentppm-$expectedppm)]
#				set differenceup   [expr abs ($currentppmup-$expectedppm)]
#				set differencedown [expr abs ($currentppmdown-$expectedppm)]				
#
#				 if {$differenceup < $differencedown} {
#				 set ppmpeak [expr {($differenceup < $difference) ? $currentppmup:$currentppm}]
#				 } else {
#				 set ppmpeak [expr {($differencedown < $difference) ? $currentppmdown:$currentppm}]
#				 }
#				} else {
			 	set ppmpeak [nv_peak elem $dimension.P $peaklist.$peaknumber]
#				}

			 set hit [concat $hit "$peaklist.$peaknumber $ppmpeak"]

			 }
			incr dimindex 1
			} 
		}
	}
	
	# store all peaks found in a matrix for further analysis
	set chemicalshift($i) $hit
}


# Average the shifts and report possible assignment errors

for {set i 0} {$i<=$numberatoms} {incr i 1} { 

  set averageresults($i) ""
  set hits $chemicalshift($i)
  set numberhits [llength $hits] 
  if {$hits!=""} {
	set resname         [nv_atom elem rname $i]
	set atomname        [nv_atom elem aname $i]
	set seqnum          [nv_atom elem seq $i]
	set minimum [lindex $hits 1]
	set maximum [lindex $hits 1]
	set total 0
	set numbers ""
	# extract the chemical shifts out of the hits
	
	
		for {set j 1} {$j<$numberhits} {incr j 2} {
			set ppmvalue [lindex $hits $j]
			set total [expr $total + $ppmvalue]
			set minimum [expr {($ppmvalue < $minimum) ? $ppmvalue:$minimum}]
			set maximum [expr {($ppmvalue > $maximum) ? $ppmvalue:$maximum}]

		}
	set average [expr $total/$numberhits*2]
	set currentppm [nv_atom elem ppm $i]
	set BMRB $amino($resname,$atomname,shift)
	set deltaBMRB [expr $average - $BMRB]

	if {$currentppm>-1000} {
		set delta [expr $average-$currentppm]
		set averageresults($i) [format "%-4s%6s%6s%11.3f%11.3f%11.3f%11.3f" $resname $seqnum $atomname $average $delta $BMRB $deltaBMRB]
		} else {
		set delta ND
		set averageresults($i) [format "%-4s%6s%6s%11.3f%11s%11.3f%11.3f" $resname $seqnum $atomname $average $delta $BMRB $deltaBMRB]
	}

	
	# check if the chemical shifts for atom i have the following properties
	# maximum - minimum > tolerance => PEAK VIOLATION
	# abs (ppmvalue - maximum) > tolerance => SHIFT VIOLATION
	# abs (ppmvalue - minimum) > tolerance => SHIFT VIOLATION
	# have to check first what kind of atom it is (a carbon, a proton or a nitrogen)
	# all these atoms might have different tolerence for differences in their chemical shifts values
	
	switch [string range [nv_atom elem aname $i] 0 0] {
	 N {set tolerance $nitrogentolerance}
	 C {set tolerance $carbontolerance}
	 H {set tolerance $protontolerance}
	}


#puts "$resname $seqnum $atomname $maximum $minimum"

	if {$maximum-$minimum > $tolerance} {
		.report.cpd24.01 insert end "PEAK VIOLATION: $resname $seqnum $atomname values from $minimum to $maximum"
		.report.cpd24.01 insert end "all peaks found:"
		for {set j 0} {$j<$numberhits} {incr j 2} {
			.report.cpd24.01 insert end "[lindex $hits $j]    [lindex $hits [expr $j+1]]"
		}
		.report.cpd24.01 insert end ""
	}




	for {set j 1} {$j<$numberhits} {incr j 2} {
	set ppmvalue [lindex $hits $j]
	set diff1 [expr abs($ppmvalue-$minimum)]
	set diff2 [expr abs($ppmvalue-$maximum)]

	if {$diff1 > $tolerance && $diff2 > $tolerance} {
		set peaklistandnumber [lindex $hits [expr $j -1]]
		set dummy           [string first . $peaklistandnumber]
		set errorpeaknumber [string range $peaklistandnumber $dummy end]
		set errorpeaknumber [string trimleft $errorpeaknumber .]
		set errorpeaklist   [string range $peaklistandnumber 0 [expr $dummy-1]]
		set largest         [expr {($diff1 > $diff2) ? $diff1:$diff2}]
		.report.cpd24.01 insert end "SHIFT VIOLATION by: $largest ppm for $resname $seqnum $atomname in $errorpeaklist peak #$errorpeaknumber (set to $ppmvalue ppm)"
		.report.cpd24.01 insert end " "
	}
	
	}

	# end of if
 	}


}



for {set i 0} {$i<=$numberatoms} {incr i 1} { 
 if {$averageresults($i) !=""} {
	.report.cpd28.01 insert end $averageresults($i)
	}
}


#bell
puts ""; puts Done
# end of procedure
}


###########################
#
# Assign Shift procedure
#
###########################

proc AssignShift {} {
if {[selection own]==".report.cpd28.01"} {
	set selected [selection get]
	set residuenum [lindex $selected 1]
	set atomname [lindex $selected 2]
	set ppm [lindex $selected 3]
	set atomnumber [nv_atom num $residuenum.$atomname]
	puts "assign $residuenum.$atomname $ppm"
	nv_atom elem ppm $atomnumber $ppm
}
}


###########################
#
# Assign All Shift procedure
#
###########################

proc AssignAllShift {} {
for {set i 0} {$i<[.report.cpd28.01 size]} {incr i} {
	set currentline [.report.cpd28.01 get $i $i]
	set selected [lindex $currentline 0]
	set residuenum [lindex $selected 1]
	set atomname [lindex $selected 2]
	set ppm [lindex $selected 3]
	set atomnumber [nv_atom num $residuenum.$atomname]
	puts "assign $residuenum.$atomname $ppm"
	nv_atom elem ppm $atomnumber $ppm
}
}

###########################
#
# Save Shift report
#
###########################


proc SaveShiftReport {} {
global tk_version tk_strictMotif
set tk_strictMotif 0

set file [tk_getSaveFile -initialdir [pwd]  -initialfile "avg-shift.report"]

set createreportfile [open $file w]

puts $createreportfile "Peak lists used:"
puts $createreportfile [.fillshifts.cpd48.01 get 0 end]

#write errors at the top
for {set i 0} {$i<[.report.cpd24.01 size]} {incr i} {
	set currentline [.report.cpd24.01 get $i $i]
	set currentline [lindex $currentline 0]
	puts $createreportfile $currentline
}

puts $createreportfile " "

puts $createreportfile [format "%-4s%6s%6s%11s%11s%11s%11s" RES NUM ATOM average delta BMRB deltaBMRB]
for {set i 0} {$i<[.report.cpd28.01 size]} {incr i} {
	set currentline [.report.cpd28.01 get $i $i]
	set currentline [lindex $currentline 0]
	puts $createreportfile $currentline
}


close $createreportfile
}



proc reportshiftsinterface {} {

if {![winfo exists .reportfillshifts]} {
       makereportfillshifts
    } else {
     wm deiconify .makereportfillshifts
    }
}

proc makereportfillshifts {} {

set base .report

    toplevel $base -class Toplevel \
         
    wm focusmodel $base passive
    wm geometry $base 506x542+145+224
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Report"
    label $base.lab21 \
        -borderwidth 1  \
        -text {Errors: Peak assignments and shifts violations} -font {Helvetica -12 bold}
    frame $base.cpd24 \
        -borderwidth 1  -height 30 -relief raised -width 30 
    listbox $base.cpd24.01 \
         \
        -font {Helvetica -12} \
         -xscrollcommand {.report.cpd24.02 set} \
        -yscrollcommand {.report.cpd24.03 set} 
    scrollbar $base.cpd24.02 \
        -borderwidth 1 -command {.report.cpd24.01 xview} -orient horizontal \
        -width 10 
    scrollbar $base.cpd24.03 \
        -borderwidth 1 -command {.report.cpd24.01 yview} -width 10 
    label $base.lab25 \
        -borderwidth 1 -text {Chemical shifts averaging results} -font {Helvetica -12 bold}
    frame $base.cpd28 \
        -borderwidth 1  -height 30 -relief raised -width 30 
    listbox $base.cpd28.01 \
         \
         -font {Courier -12}\
         -xscrollcommand {.report.cpd28.02 set} \
        -yscrollcommand {.report.cpd28.03 set} 
    scrollbar $base.cpd28.02 \
        -borderwidth 1 -command {.report.cpd28.01 xview} -orient horizontal \
        -width 10 
    scrollbar $base.cpd28.03 \
        -borderwidth 1 -command {.report.cpd28.01 yview} -width 10 
    button $base.but29 \
         -padx 11 -pady 4 -text Assign -font {Helvetica -12 bold} -activebackground #fe3640 -command {AssignShift}
    button $base.but30 \
         -padx 11 -pady 4 -text {Assign All} -font {Helvetica -12 bold} -activebackground #fe3640 -command {AssignAllShift}
    button $base.but31 \
         -padx 11 -pady 4 -text {Save report} -font {Helvetica -12 bold} -activebackground #fe3640  -command {SaveShiftReport}
    button $base.but32 \
         -padx 11 -pady 4 -text Quit -font {Helvetica -12 bold} -activebackground #fe3640 -command {destroy .report} 
    label $base.lab34 \
        -borderwidth 1  -relief flat  -text [format "%-4s%6s%6s%11s%11s%11s%11s" RES NUM ATOM average delta BMRB deltaBMRB] -font {courier -12} -justify left
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.lab21 \
        -x 5 -y 5 -anchor nw -bordermode ignore 
    place $base.cpd24 \
        -x 10 -y 25 -width 490 -height 165 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd24 0 -weight 1
    grid rowconf $base.cpd24 0 -weight 1
    grid $base.cpd24.01 \
        -in $base.cpd24 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd24.02 \
        -in $base.cpd24 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd24.03 \
        -in $base.cpd24 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.lab25 \
        -x 10 -y 205 -anchor nw -bordermode ignore 
    place $base.cpd28 \
        -x 15 -y 265 -width 485 -height 230 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd28 0 -weight 1
    grid rowconf $base.cpd28 0 -weight 1
    grid $base.cpd28.01 \
        -in $base.cpd28 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd28.02 \
        -in $base.cpd28 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd28.03 \
        -in $base.cpd28 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.but29 \
        -x 20 -y 500  -anchor nw -bordermode ignore 
    place $base.but30 \
        -x 95 -y 500 -anchor nw -bordermode ignore 
    place $base.but31 \
        -x 185 -y 500 -anchor nw -bordermode ignore 
    place $base.but32 \
        -x 290 -y 500  -anchor nw -bordermode ignore
    place $base.lab34 \
        -x 18 -y 248 -anchor nw -bordermode ignore 
}
