#########################################################################################
# NMRView Navigator
#
# Original idea: Vincent Raussens
# Maintained and developed by Pascal Mercier
# Consult me for modifications, problems, or any good ideas.


# Pascal Mercier
# pascal.mercier@ualberta.ca
# CHRC group in protein structure and function
# Brian Sykes lab
# Department of Biochemistry
# University of Alberta
# Edmonton, Canada
#########################################################################################


# to do
# the history panel should update to move down to the last item by default 


#Version 6.2
#fixed a resize display: wm geometry does not work entirely properly with NMRVIewJ
#Add to make so adjustments for nmrviewJ 6.2.8
#Made it more idiot-proof
#Fixed ballon tips for buttons that had been swapped

#Version 6.1
#starting to think to drop C support completly
#fixed the listboxes for NMRViewJ 6.2.3.  that version does not respect the wm resizable settings

#Version 6.08
#brought back spectrum annotations compatibility with Java

#Version 6.07
# Now handles methyl groups ided with M*. update navig_logan_parentlist
# fix a bug with an append command that did not have an extra space at the end.

# Version 6.05
# Changed the listboxes to be java compatible (using jscollpane).  Many thanks to Bruce Johnson for all the tricks
# Added bindings to the list box so that the user can double click on an item now

#Version 6.03
# minor fix: the line if {$childatomname != ""}  was not put at the right place, so that the navigator could not figure out what the indirect dimension was if the user would ask for a carbon atom that was assigned, but not it's protons.  this was generating an error.
# any new items in the history or view list is now added at the top, not at the bottom

# Version 6.02
# Added orange cursors for the Java version


# Version 6.01
# created a new procedure (navig_calc_directdimension_ppm_range) so that keys.tcl could use it

# Version 6.0
# Thanks to Logan Donaldson for reporting bugs
# Decided to switch version numbering to 6 to follow NMRView's numbering
# Java compatible (with 6.01 release).  lots of changes in the code to accomodate this.

# The autozoom now takes into account the size of the window so that peaks will look as rounded as possible, not stretched (the navigfocustightoffset is not set to a constant no more).  Thanks to Ryan Hoffman for this idea
# To accomplish this, the navigator calculates (only once for each peak list) the proper x/y display ratio based on peak width/heights
# When talking to pipp_nav, no longer assumes that the direct dimension is on the x axis
# Fixed things when a window with no dataset would exist.  It's not allowed to issue a command to the navigator from a window.  It keeps things simple this way.
# put a timer to remind the user to not do anything while nmrview is redrawing spectra if it takes more than one second


#Version 5.2.1
#Fixed a bug for pipp_nav when the user would ask for a carbon or nitrogen plane (residue mode) and the protons attached to the C or N atom were not assigned


#Version 5.2
#The navigator "talks" to pipp_nav 
#Get pipp_nav from Stephane Gagne lab at http://nmr.ulaval.ca/labo/software.html
#Added gray icons when options are deselected.
#Another Logan Donaldson (York University) fix: navigator was not able to put the cursors on negative shifts 
#fixed a bug with the view selection button that would report an error when no view was selected 
#fixed bugs at startup when the user would choose a mode while no active window was opened or sequence loaded (thanks to Leigh Willard, Laval University)
#plane mode is the default selected mode when the navigator starts
#moved code around to avoid having to update the spectrum twice in some cases
#fixed several bugs when dealing with 2D spectra
#uUses a new approach to restore the last view: Before the user takes any action with the navigator, the state of all windows that existed before the change is stored in memory.  Hitting the previous view button retrieves this view for the active window if the globalview option is on, otherwise it only bring back the last state of the active window.

#Version 5.1
#Thanks to Logan Donaldson, York University, who reported a bug with the nv_atom elem parent command
#In some cases the command does not seem to send back the right result
#The strategy was to manually define a list of parent atoms for each type of proton
#To avoid file dependancy, the list is stored in a variable navig_logan_parentlist
#Added a color change for the navigator under NMRViewAqua

#Version 5.0
#This is a major release!
#Added multi-plane capabilities. Had to segment the first section in two frames
#Made the z planes to be dispayed with no more than 3 digits
#Added to line to say where the cursor was positioned when requesting a 15N plane
#Added the possibility to automatically expand around a residue chemical shift when asking for it
#This last feature is not complete yet (in next version, want to add preference panel for this to set some options
#Following Tharine's request, the zoom out button takes into account the zoom options
#Changed the focus color from red to yellow for the option buttons"
#New icons, BDS size compatible
#Changed the graphical interface (packer, grid, no place)
#Added a line to correct for a potential bug when the user would retrieve a view and the window would not exist anymore
#Cleaned some console outputs that were used for debugging

#Things to add in 5.1:
#option to save and retrieve views on the disk
#output everything to a "navigator console" instead of the main console

#Version 4.5
#Are the bugs ever going to end?
#Added a feature to position the red cursor when asking for a proton residue (ex 10.HA).  That's all it does for now.  I will try to finish up this feature later on

#Version 4.4
#Version 4.3 was buggy! It would get peak lists messed up.  I added an update statement to fix that
#Also, when asking for a residue, it would generate an error message with a 2D spectrum


#Version 4.3
#when asking for a residue, the navigator now makes sure its chemical shift can be displayed within the limit of the spectral window
#when asking for a residue, the navigator now stays in residue mode (the z command also works with a residue number, so there is no need to swtich back to the ppm mode like it did before


#Version 4.3b1
# still need to do: check if a spectrum has to be redisplayed or not for faster speed
# still need to do: when back to the active window, make sure the spectrum limits include the residue the user requested
#added an update command.  Sometimes the cursors were not positioned at the right place because the display settings in one of the windows affected by the navigator did not cover the target position of the cursor
# corrected a bug introduced in 4.2 with the dot extension automatic detection

# Version 4.2
# the user can now enter dot extensions in lowercase
# if the nav detect the user has enter a number with a dot extension it will switch to res mode automatically
# fixed a glitch that would cause an item in the history list to be added again in the history list upon being choosen
# fixed another glitch that would cause the navigator to say it had positioned the cursor even though there were no assignments for the protons


# Version 4.1
# added balloon tips

# Version 4.0
# all colored interface - no gray !
# added an option for automatic positionning or not


# Version 3.9
# better intuitive icons ? 
# colored icons (gif files)

# Version 3.8
# included automatic cursor positionning when requesting a residue

# Version 3.7
# replace all buttons by b&w icons
# added a section for saving and retrieving views
# added the option to record the history or not
# the expand/shrink button for the history section remembers how the size of the previous size of the window 
# the interface is now divided in 3 sections using frames

# Version 3.6
# replaced some buttons by icons to save desktop space


# Version 3.5
# I decided to include the history window in the previous version directly into the navigator window
# An arrow button gives access to it
# There is no need anymore to add the .N prefix when wanting to jump to the 15N plane of a residue
 
# Version 3.4
# Introduction of the history window
# Does inteligent "jumping".  Will only jump to planes if the third dimension of the window's dataset is
# properly labeled. 

# Version 3.3
# Fix a bug that would cause an error when the peakid window was opened.  
# This was caused by the fact that the command [nv_win open] also returns the peakid window if it's opened
# Fixed by adding the matching pattern pat2

#
# Version 3.2
# The interface uses the placer manager instead of the packer.  This allows for better alignment

# Version 3.1
# June 26, 2001
# Rewitten for nmrview 5.0.3 
# Now uses the built-in functions z and zp
# Lighter code.  Now written more intelligently. Got rid of unnecessary variables
# the zoom and go button now do not only work in the active window, but all windows opened if the user chooses so


# Version 3
# June 19, 2001
# When two or more experiments did not have the same rfl in the 3rd dimension, a bug would cause the navigator window
# to go to the wrong plane when the "Go apply to all spectra" option was checked.   
# Fixed by adding the variable originalrequest.



#########################################################
#														#
# Procedure to show About Navigator	                	#
#														#
#########################################################


proc navig_about {} {
	global Nv_Priv
	set f .help
	destroy $f
	toplevel $f

	wm title $f "Navigator help"

	pack [frame $f.fr]
	
	if {!$Nv_Priv(javaMode)} {
		# for C
		pack [text $f.fr.tx  -width 60 -font {Helvetica -12}\
			-yscrollcommand {.help.fr.sb set} ] -side left
		pack [scrollbar $f.fr.sb -background lightblue \
				-activebackground lightblue \
    	    	-width 10 -borderwidth 1 -command {.help.fr.tx yview}  \
			 ] -fill y -side right
	} else {
		#for Java
		jscrollpane $f.fr.javascroll
		text $f.fr.tx  -width 60 -font {Helvetica -12}
		$f.fr.javascroll add $f.fr.tx 
		pack $f.fr.javascroll -in $f -side top -expand 1 -fill x
	}
	
	pack [button $f.b1 -text Done -default active -activebackground red \
		-command {destroy .help}] -side bottom

	$f.fr.tx insert end {The main purpose of this NMRView plug-in in to help the user to easily navigate through multiple spectra, easily save views to memory and disk, quickly restore them, set spectral limits automatically in multiple spectra, jump to specific planes corresponding to specific residues, etc.

The navigator window is an original idea of Vincent Raussens.  It was first implemented in NMRView 3 and has been developed and updated since by Pascal Mercier at the University of Alberta, Edmonton, Canada.  Send any request, ideas and bug report to pascal.mercier@ualberta.ca. 

This software is free and is provided as is. Please do not distribute this software.  Any changes must be submited to the author.  Thanks for your collaboration.

There are some limitations associated with the navigator.  Please read the documention that comes with this software.

	}
}

#########################################################
#														#
# Procedure to zoom in several spectra at once         	#
# works only with spectra displayed in a same window   	#
# based on "Ctrl-e" key binding script                 	#
#														#
#########################################################

proc NavigZoom {} {

global onlyselfcheck
global zoomrelated
global allwin
global originalrequest



set originalwindow [nv_win act]

set windows_to_operate_on [WindowsAffectedBynNavig]
if {$windows_to_operate_on==""} {return}

if {[lindex $windows_to_operate_on 1]==""} {
	# only the active window has to be expended
	nv_win expand
} else {

	set name_win [nv_win act]
	set coord1x [nv_win cross1x]
	set coord1y [nv_win cross1y]
	set coord2y [nv_win cross2y]
	set coord2x [nv_win cross2x]
	set nameaxisx [nv_win lab x]
	set nameaxisy [nv_win lab y]
		     
	foreach item $windows_to_operate_on {  
	
		nv_win act $item
		if {$zoomrelated} {
			#zoom only in related spectra
			#check if the windows_to_operate_on window can be expanded
			#(same x and y axis as the original spectrum)

 			if {[nv_win lab x]==$nameaxisx && [nv_win lab y]==$nameaxisy} {
				nv_win full
 				#nv_win draw
				nv_win cross1 $coord1x $coord1y
				nv_win cross2 $coord2x $coord2y
				nv_win expand
			}
			
			if {[nv_win lab y]==$nameaxisx && [nv_win lab x]==$nameaxisy} {
			nv_win full
 			#nv_win draw
 			nv_win cross1 $coord1y $coord1x
  			nv_win cross2 $coord2y $coord2x
			nv_win expand
			}
		} else {
			#zoom only in related spectra not checked
			#all spectra are gonna be expanded in the area chosen
			nv_win full
			nv_win cross1 $coord1x $coord1y
			nv_win cross2 $coord2x $coord2y
			nv_win expand
		}
    }
    
# return to the original window
nv_win act $originalwindow
}

}



#########################################################
#														#
# Procedure to fully expand several spectra at once     #
# works only with spectra displayed in a same window    #
# based on "Ctrl-f" key binding script                  #
#														#
#														#
#suggestion for next release:							#
#to save tim on display, check if the window really		#
#needs to be redrawn before doing a nv_win full			#
#########################################################

proc NavigExpand {} {

global onlyselfcheck
global allwin
global zoomrelated

set originalwindow [nv_win act]
set windows_to_operate_on [WindowsAffectedBynNavig]
if {$windows_to_operate_on==""} {return}

if {[lindex $windows_to_operate_on 1]==""} {
	# only the active window has to be expended
	nv_win full
} else {


set name_win [nv_win act]
	set coord1x [nv_win cross1x]
	set coord1y [nv_win cross1y]
	set coord2y [nv_win cross2y]
	set coord2x [nv_win cross2x]
	set nameaxisx [nv_win lab x]
	set nameaxisy [nv_win lab y]
		     
	foreach item $windows_to_operate_on {  
	
		nv_win act $item
		if {$zoomrelated} {
			#zoom only in related spectra
			#check if the windows_to_operate_on window can be expanded
			#(same x and y axis as the original spectrum)

 			if {([nv_win lab x]==$nameaxisx && [nv_win lab y]==$nameaxisy) || ([nv_win lab y]==$nameaxisx && [nv_win lab x]==$nameaxisy)} {
				nv_win full
 			}
			
			
			
		} else {
			#zoom only in related spectra not checked
			#all spectra are gonna be expanded in the area chosen
			nv_win full
			}
    }



nv_win act $originalwindow
}	
}



#########################################################################
#																		#
# Procedure to go to the previous view in several spectra at once  		#
# works only with spectra displayed in a same window               		#
# based on "Ctrl-p" key binding script                             		#
#																		#
#########################################################################

proc NavigPrevious {} {
	NavigRestoreView memory
}


#########################################################
#														#
# Procedure to show waiting dialog box					#
#########################################################

proc nav_wait { mode } {

global navigator_busy_active navigator_busy_after

   switch $mode {
        on {
            set navigator_busy_after [after 750 nav_wait show]
            set navigator_busy_active 0
            update
        }
        off {
            catch "after cancel $navigator_busy_after"
            if {[winfo exists .nav.waitwindow]} {destroy .nav.waitwindow}
            set navigator_busy_active 0
            
        }

		show {
            if {[winfo exists .nav.waitwindow]} {
                destroy .nav.waitwindow
            }
            set win .nav.waitwindow
            toplevel $win

			wm geometry $win +400+250
			wm title $win "WAIT"

			pack [frame $win.fr1 -relief flat ] -pady 10
			pack [label $win.fr1.lbl1 -text "Please wait.\nDrawing windows." -font {Helvetica 14 bold}] -pady 20 -padx 10 
			tkwait visibility .nav.waitwindow
		}
	}
}


#########################################################
#														#
# Procedure to go to a specific plane (in Z-dim)		#
# or any chemical shift, or a residue chemical shift	#
#														#
# based on "Ctrl-z" key binding script            	 	#
#														#
#########################################################

proc NavigGoToPlane {} {

global Nv_Priv
global onlyselfcheck unitp curnumdisplayed curnumdisplayed2 originalrequest originalrequest2 navhistoryrecord
global cursorautopos Nv_Natoms comingfromhis navigmultiplane focustight
global navigfocustightoffset_default
global navig_logan_parentlist
global navig_for_last_view
global myvar pn_pattern
global navig_peak_width_height_ratio 
global string_for_no_shift_available
global NvassignPanel navig_synchronize_asspanel
global navig_adjust_indirectdim
global navigfocustightoffset

set windows_to_operate_on [WindowsAffectedBynNavig]

if {$windows_to_operate_on==""} {return}

set originalrequest  [string toupper [.nav.fra60.01.ent22 get]]
set originalrequest2 [string toupper [.nav.fra60.01.ent25 get]]

#make sure there is a sequence loaded when  asking for a residue
if {$Nv_Natoms==0 && $unitp==2} {
        bell
        puts "Navigator> You are in residue mode and there is no sequence loaded in memory"
        return
}

#sometimes it happens that one wants a residue chemical shift but forgets to choose the res mode
#in that case switch to res mode 
if {[string match *\[C|N|H\]* $originalrequest]} {set unitp 2}

if {$unitp==2} {
	set askforresidue true
	if {$navigmultiplane} {changemultiplanemode}
} else {
	  set askforresidue false
}
	
	
# first make sure there is assignments in case the user asked for a residue
# and that the atom exists
if {$unitp==2} {
	if {[string first . $originalrequest]==-1} {
		set addition ".N"
	} else {
		set addition ""
	}
	
	set error [catch "nv_atom elem ppm $originalrequest$addition" class]
	if {$error} {
		bell
		if {$originalrequest=="N/A"} {
			puts "Navigator> you must enter a residue number followed by an atom identifier (10.CB for example)"
		} else {
			puts "Navigator> there is no such atom for residue [file root $originalrequest]"
		}
		return
	}
	
	if {[nv_atom elem ppm $originalrequest$addition]==$string_for_no_shift_available} {
		bell;
		puts "Navigator> there is no assignment for $originalrequest$addition"
		return
	}
}


# add the request to the history window if history record in on
if {$navhistoryrecord && $originalrequest!="It's a 2D"} {
	switch -exact -- $unitp {
		0 {set addition "(plane)"}
		1 {set addition "(ppm)"}
		2 {set addition "(residue)"}
	}

if {!$navigmultiplane} {
	.nav.fra62.cpd22.01 insert 0 "$originalrequest $addition"
	} else {
	.nav.fra62.cpd22.01 insert 0 "$originalrequest to $originalrequest2 $addition"
	}
}

if {$comingfromhis} {set navhistoryrecord 1;set comingfromhis 0}


#get info about the current window.  After the process the active window will be that one.
#check if there is at least spectral window
set error [catch "nv_win act" class]
if {$error} {bell; puts "Navigator> No spectral window exists"; return}


set originalwindow [nv_win act]
#check what kind of option was chosen (plane, ppm or res)
# if it's residue, extract information about the residue

if {$unitp==2} {
   
	#check if only a number was entered or if a number was entered with an atom specified	
	# ex: 128 versus 128.N or 128.CA	
	# if only a number was chosen the option apply to all won't be respected.  
	#Right now the program assumes the active window/spectrum is an hsqc.
   
  if {[string first . $originalrequest] < 0 &&  [nv_win ndim]==2} {
	# only a number was entered 
	# have to put the cursor on the residue chosen
	# have to check first what kind of experiment it is
	
	set xlabel [nv_win label x]
    set ylabel [nv_win label y]

    # determine where the cursor should go
	set chemshift1 [nv_atom elem ppm $originalrequest.HN]
    set chemshift2 [nv_atom elem ppm $originalrequest.N]
 		
	#check if the program has assignment for the chosen residue
    if {$chemshift1==$string_for_no_shift_available || $chemshift2==$string_for_no_shift_available} {
			bell
			puts "Don't have assignment for $originalrequest.N or $originalrequest.HN."
			return
		}

      		
     		#now check if the window has to be expanded before putting the cursor on it
     		set xmax [lindex [nv_win ppm x] 0]
     		set xmin [lindex [nv_win ppm x] 1]
     		set ymin [lindex [nv_win ppm y] 0]
     		set ymax [lindex [nv_win ppm y] 1]
		
      	if {$chemshift1 > $xmax || $chemshift1 < $xmin || $chemshift2 > $ymax || $chemshift2 < $ymin} {nv_win full}

		# finally, put the cursor on the right peak
	
		if {[string match *H* [nv_dataset label [nv_win dataset] [nv_win xdim]]]} {
      		nv_win cross2 $chemshift1 $chemshift2
		} else {
			nv_win cross2 $chemshift2 $chemshift1
		}
   		puts "put the [[nv_win act] crosscolor 2] cursor on residue $originalrequest"
		
  		#Don't do anything else.  Exit here
   		return
   	}


    	if {[string first . $originalrequest] ==-1 &&  [nv_win ndim]>2 && [string match "*C*" $originalrequest]} {
				bell
				puts "To jump to a given 13C plane of a residue you must specify a C atom.  For instance: 128.CA, 128.CB"
				return
      }

		
		#if the user only types a number, by default make it .N
		if {[string first . $originalrequest] ==-1} {
			set originalrequest [concat $originalrequest.N]
			#the last addition in the history window does not have the .N prefix.  have to add it
			if {$navhistoryrecord} {
				set lastaddition [lindex [.nav.fra62.cpd22.01 get 0 0] 0]
				set newaddition [concat [lindex $lastaddition 0].N (residue)]
				.nav.fra62.cpd22.01 delete 0 0
				.nav.fra62.cpd22.01 insert 0 $newaddition 
			}
		}
		
		set askforresidue true
		set originalresrequest $originalrequest
		set childatomname ""
		
		set resnumber [file root $originalresrequest] 
		set extension [file extension $originalresrequest]
			
		if {[string first "C" $originalrequest]!=-1} {
		
			# the user asked for a 13C plane
			set matchingDatasetPat "*C*"
		
			#check if the user has a chemical shift for the Cx atom
			set CxchemShift [nv_atom elem ppm $originalresrequest]
			
			if {$CxchemShift!=$string_for_no_shift_available} {
				# since 5.1, does not use nv_atom elem parent no more
				set childatomname [navig_getchildatomname $originalresrequest]
			} else {
				#there is no chemical shift associated with that carbon
				bell
				puts "WARNING: there is no chemical shift information for $originalrequest"
				#exit here
				return
			}
		}
		
		

		if {[string first "N" $originalrequest]!=-1} {
			# the user has asked for a 15N plane
			set matchingDatasetPat "*N*"

			#check if the user has a chemical shift for the N15 atom
			set N15chemShift [nv_atom elem ppm $originalresrequest]
			if {$N15chemShift!=$string_for_no_shift_available} {
				set childatomname [navig_getchildatomname $originalresrequest]
			} else {
				puts "WARNING: there is no chemical shift information for $originalresrequest"
				#exit here
				return
			}
		}
			
			
		if {![string match "*\[CN\]*" $originalrequest] || [string match "*HN" $originalrequest] } {
			# the user did not asked for C or N atom
			# will consider only a proton was requested. Just assumes a 2D spectrum
			set matchingDatasetPat ""
			set childatomname $originalrequest
		}		
} 
 

 
if {[llength $windows_to_operate_on]==1} {

	if {[nv_win ndim]<3 && $matchingDatasetPat!=""} {			
		puts "this is a 2D spectrum.  Cannot execute this task"
		return
	}
set windows_to_operate_on [nv_win act]
}


if {!$Nv_Priv(javaMode)} {nav_wait on}

#Save the current view in memory
set navig_for_last_view [NavigSaveView memory]



	#loop through all spectra according to the different options chosen
	foreach item $windows_to_operate_on {
			set needredraw 0
			nv_win act $item		
			set currentdataset [nv_win dataset]
			set numberdim [nv_dataset ndim $currentdataset]
			set needszooming 0

			
			if {$askforresidue && $numberdim>1} {
				#skip all of this if the user requested something different than HN and the active window is an N15hsqc
				#we don't want to focus at all (does not make sense trying to focus around an HA for instance)
				if {$numberdim==2 && $childatomname!="HN"} {
					# check the dataset dimension to see if they are named "HN, H" and "N15, 15N or N"
					set label "[nv_dataset label $currentdataset 1] [nv_dataset label $currentdataset 2]"
					if {[string match *N* $label]} {continue}
				}
				
				if {$numberdim==3} {set namethirddim [nv_dataset label $currentdataset 3]} else {set namethirddim ""}
				
				#check if the window needs to be expended to show the residue
				#must have had chemical shift information for the childatom to do that
				#for a 3D, the name of the third dimension has to be related to the type of atom the the user wants
					
				#should a 2D autozoom on a residue when asking for it from a 3D?
				#for instance, asking for a .N plane in a 3D-noesy would cause a 2D-noesy to zoom around the HN atom
				#this behavior can be activated by deleting && $matchingDatasetPat=="" in the line below 
				if {($numberdim> 2 && [string match $matchingDatasetPat $namethirddim])	||	($numberdim==2 && $matchingDatasetPat=="")} {		

										
					set datasetdisplayed [nv_win dataset]
					set peaklistdisplayed [nv_win dispeaks]
				
					#check if there is a peaklistdisplayed
					#if none, check if there is any peak list opened related to the dataset
					
					
					#make C version = J version (empty string)
					if {$peaklistdisplayed=="none"} {set peaklistdisplayed ""}
					if {$peaklistdisplayed==""} {set peaklistdisplayed  [navig_get_relatedpeaklist $datasetdisplayed]}
					#check if the relation for the peaklist has been set
					#set the peak relation empty for a 2D
					
					if {$numberdim>2 && $peaklistdisplayed!=""} {
						set peakrelation [nv_peak relation $peaklistdisplayed]
					} else {
						set peakrelation ""
					}
					
					
					##################################################
					# Determine the direct and indirect dimensions
					##################################################
					
					if {$peaklistdisplayed==""} {
						# there is no peak list displayed
						# assume the direct dimension is x
						set directdimension_on_axis x
					} else {
						# have to determine which dimension is the direct dimension
						# D3 must be present in the peak relation
						if {[string match "*D3*" $peakrelation]==0} {
							# D3 is not specified
							# assume the direct dimension is x
							set directdimension_on_axis x
							set namedim_havingD3 [nv_win label x]
						} else {
							# D3 is specified
							set dimhavingD3 [lsearch $peakrelation *D3*]
							set namedim_havingD3 [lindex [nv_peak label $peaklistdisplayed] $dimhavingD3]
							set directdimension_on_axis x
							#check if the display is swapped
							if {[nv_win label y]==$namedim_havingD3} {set directdimension_on_axis y}
						}
					}
				
					if {$directdimension_on_axis=="x"} {set indirectdimension_on_axis y} else {set indirectdimension_on_axis x}

					
					if {$childatomname != ""} {				
						
						##########################################################
						# check if the user wants the y axis to be adjusted
						# Logan Donaldson suggested to put this back in version 6
						# Thx Logan but you're making me work!
						##########################################################

						switch $navig_adjust_indirectdim {
						
							1 {
								# the user wants to at least cover the requested residue
								set needredraw [navig_check_zooming_needed $indirectdimension_on_axis $childatomname]	
							}
							
							2 {
								# the user wants to set the limits according to a peak list								
								# if there is not peak list displayed try to find a related peak list
								if {$peaklistdisplayed!=""} {
									set original_template_currlist [nv_peak template $peaklistdisplayed]
									set peaksfound ""
									
									# check if the spectrum is a 2D or a 3D
									switch $numberdim {
										2 {
											if {[string range [nv_win label $directdimension_on_axis] 0 0]=="H"} {set errorrange 0.05} else {set errorrange1 0.5}
											eval nv_peak template $peaklistdisplayed "[nv_win label $directdimension_on_axis] $errorrange"
											foreach atom $childatomname {append peaksfound "[nv_peak find $peaklistdisplayed [nv_atom elem ppm $atom]] "}
										}
										
										3 {
											eval nv_peak template $peaklistdisplayed "$namedim_havingD3 0.05 $namethirddim 0.5"
											foreach atom $childatomname {append peaksfound "[nv_peak find $peaklistdisplayed [nv_atom elem ppm $atom] [navig_calculate_folded_shift $originalresrequest]] "}
										}
									}
									# reset the peak template to its original setting
									eval nv_peak template $peaklistdisplayed $original_template_currlist
								
									if {$peaksfound!=""} {
										#now extract shifts in the indirect dimension of all the peaks that were found
										set name_dim_indirect [nv_win label $indirectdimension_on_axis]
										set shifts ""
										foreach peak $peaksfound {
											set peaknumber [lindex  [split $peak .] 1]
											#puts "peaknumber is $peaknumber"
											#puts "trying to do nv_peak elem $name_dim_indirect.P $peaklistdisplayed.$peaknumber"
											lappend shifts [nv_peak elem $name_dim_indirect.P $peaklistdisplayed.$peaknumber]
										}
										set shiftmax [navig_max $shifts]
										set shiftmin [navig_min $shifts]
										nv_win ppm $indirectdimension_on_axis [expr $shiftmin -0.5] [expr $shiftmax + 0.5]
										set needredraw 1
									} else {
										puts "Navigator>> Could not change the limits of the dimension [nv_win label $indirectdimension_on_axis] in $item because there is no peak list reated to the dataset $currentdataset"					}
									
								} else {
									puts "Navigator>> Could not change the limits of the dimension [nv_win label $indirectdimension_on_axis] in $item because no peak list related to the dataset $currentdataset could be found"
								}
							}
							
							
							3 {
								# aliphatic region up to 5.5 ppm
								set maxrange [nv_win ppmMax $indirectdimension_on_axis]
								nv_win ppm $indirectdimension_on_axis [lindex $maxrange 0] 5.5
								set needredraw 1
							}
							
							4 {
								# amide region
								set maxrange [nv_win ppmMax $indirectdimension_on_axis]
								nv_win ppm $indirectdimension_on_axis 6.5 [lindex $maxrange 1]
								set needredraw 1
							}
							
							5 {
								# 1/2 half
								set maxrange [nv_win ppmMax $indirectdimension_on_axis]
								nv_win ppm $indirectdimension_on_axis [lindex $maxrange 0] [expr [lindex $maxrange 1]/2.]
								set needredraw 1
							}
						
							6 {
								# last half
								set maxrange [nv_win ppmMax $indirectdimension_on_axis]
								nv_win ppm $indirectdimension_on_axis [expr [lindex $maxrange 1]/2.] [lindex $maxrange 1]
								set needredraw 1
							}
							
							7 {
								# the user wants to expand the indirect dimension to full
								set maxrange [nv_win ppmMax $indirectdimension_on_axis]
								nv_win ppm $indirectdimension_on_axis [lindex $maxrange 0] [lindex $maxrange 1]
								set needredraw 1
							}
						}
						
						

						##############################################################################
						# check if the user wants to focus tight around the peak
						# if not, just make sure that the proton shift of the associated request can be displayed in the window
						
						if {!$focustight} {
							set needredraw2 [navig_check_zooming_needed $indirectdimension_on_axis $childatomname]
							set needredraw  [navig_max [list $needredraw needredraw2]]
						} else {
							##############################
							# the user wants to autofocus
							#determine the upper and lower bound for zooming
							set minimum 999999
							set maximum -999999
							foreach atom $childatomname {
								set atomchemshift [nv_atom elem ppm $atom]
								if {$atomchemshift < $minimum} {set minimum $atomchemshift}
								if {$atomchemshift > $maximum} {set maximum $atomchemshift}
							}
							#if there is only one childatom, maximum=minimum
							#in case of two  childatoms, HB1 and HB2 for instance, the navigator will try to center the spectrum
							#around the two protons
							if {[llength $childatomname]>1} {
								set minimum_untouched $minimum
								set maximum_untouched $maximum
								set minimum [expr ($minimum+$maximum)*0.5]
								set maximum $minimum
							}
							
							#set the spectral limits for the zoom
							#try to determine if the x/y ratio for this dataset is known
							#if it's not, try to determine it from the displayed peak list
							if {![info exists navig_peak_width_height_ratio($currentdataset)]} {
								if {$peaklistdisplayed!=""} {navig_get_xyratio_peaklist $peaklistdisplayed}
							}
							
							
							if {[info exists navig_peak_width_height_ratio($currentdataset)]} {
								set navigfocustightoffset [navig_calc_directdimension_ppm_range $item $directdimension_on_axis]
							} else {
								# the user wants to autofocus but there is no peak list known for this dataset, and the x/y ratio
								# could not be determined or has not been set from the display by the user
								# assumme a the default value for navigfocustightoffset
								set navigfocustightoffset $navigfocustightoffset_default
							}
							
							
							###################
							#now autofocus
							nv_win ppm $directdimension_on_axis [expr $minimum - $navigfocustightoffset] [expr $maximum + $navigfocustightoffset]
							set needredraw 1
							
							# the method that was used for two childatoms centers the spectrum in between the two atoms
							# the spectral limits that were calculated might not include the proton themselves now
							# must make sure that the protons are contained in the spectral limits

							if {[llength $childatomname]>1} {
								set needmorefocus 0
								if {[expr $minimum - $navigfocustightoffset]>$minimum_untouched} {set newdownlimit [expr $minimum_untouched-0.3]; set needmorefocus 1}
								if {[expr $maximum + $navigfocustightoffset]<$maximum_untouched} {set newuplimit   [expr $maximum_untouched+0.3]; set needmorefocus 1}

								if {$needmorefocus} {
									nv_win ppm $directdimension_on_axis $newdownlimit $newuplimit
								}
								#set needredraw 1
							}
							#end of focus tight
						}
						
						#end of childatomname != ""
					}

					#end of matching z axis name condition (string match $matchingDatasetPat $namethirddim....)
				}
				
				
				
				if { $numberdim> 2} {
					if {[string match $matchingDatasetPat $namethirddim]} {
						DoTheChangeOfPlane; update

						# since 5.2, talk with pipp_nav
						# must determine if pipp_nav exists
						if {($extension==".N" || [string match *C* $extension]) && [info commands *pn_set_lines*]!=""} {
							
							# the user chose an N15 or C13 plane
							# check if the dataset is included in pipp_nav configuration tool
							# if it is, let the pipp_nav function go to the right plane and draw the annotations
							set myvar(res) $resnumber
							set bn [getbasename $item]
							
							if {! [info exists pn_pattern($bn,chk) ] } {set pn_pattern($bn,chk) 0}
							
							if {$pn_pattern($bn,chk)} {
								
								if {$directdimension_on_axis=="x"} {
									set pipp_nav_lines_to_affect xlines
								} else {
									set pipp_nav_lines_to_affect ylines
								}
								
								#get the x and y ppm values, in a list 
								#for 15N atoms, use Leigh's procedure
								#for 13C atoms, get the protons names with the procedure navig_getchildatomname
						
								if {$extension!=".N"} {
									# asked for a carbon plane
									# childatomname already has things like 53.HB1 53.HB2
									# if those have chemical assignments that is
									if {$childatomname==""} {
										set pn_pattern($bn,$pipp_nav_lines_to_affect) ""
									} else {
										set newpattern  "i."
										foreach kid $childatomname {append newpattern "[lindex [split $kid .] 1]|"}
										# erase the last vertical bar
										set newpattern [string trimright $newpattern |]
										# set new pattern for x coordinates
										set pn_pattern($bn,$pipp_nav_lines_to_affect) $newpattern
									}
								} else {
									# the extension is .N
									set pn_pattern($bn,$pipp_nav_lines_to_affect) "i.HN"
								}


								set ppmX [get_ppms $pn_pattern($bn,xlines)]
								set ppmY [get_ppms $pn_pattern($bn,ylines)]
		
								# ppmX will be set to an empty string if the HN atom does not exists
								# that's for a .N atom
								# for a .C atom, it will be set to -1 from the contruct above
								if {$ppmX==""} {
									puts "navigator>> WARNING: there is no chemical shift assignments for $originalrequest protons"
									puts "navigator>> WARNING: cannot put up annotations"
								}
								
								if {$ppmX==-1} {
									set ppmX ""
									puts "navigator>> WARNING: there is no chemical shift assignments for $originalrequest protons"
									puts "navigator>> WARNING: cannot put up annotations"
								}
								
								
								#put up the annotations
								pn_set_lines $item $bn $ppmX $ppmY
								NvSpectrumDrawAnno $item
							} 
						}
					#end of string match $matchingDatasetPat $namethirddim]
					} 
				#end of numdim >2	
				} else {
					# The user wants a proton shift
					# The case dealing with an hsqc as been treated in the code (see above)
					# What might happen here is the user asking for let's say a HN atom in a 2D noesy
					# We don't want the hsqc to focus around the HN atom
					if {$needredraw  || ($focustight && [string match $matchingDatasetPat $namethirddim])}  {
						NvSpectrumDraw
						#update
					}
				}

			
			} else {
		
	    	# the user entered a plane number or a value in ppm directly
			# since v. 4.4, make sure the spectrum is not a 2D if the user asked for a residue number or ppm
				if {$numberdim>2} {DoTheChangeOfPlane}
			}	
			
			#end of flipping through all windows	
   	}			  



# return to the original window when done
nv_win act $originalwindow


if {$unitp==0} {
	if {!$navigmultiplane} {
		puts "switched to plane # $originalrequest"
	} else {
		puts "switched to plane # $originalrequest to $originalrequest2"
	}
}
if {$unitp==1} {
	if {!$navigmultiplane} {
	puts "switched to plane corresponding to $originalrequest ppm"
	} else {
	puts "switched to planes between $originalrequest and $originalrequest2 ppm"
	}
}

if {$unitp==2 && $numberdim>2} {puts "switched to plane of atom $originalrequest located at [nv_atom elem ppm $originalrequest] ppm"}


#put the cursor on the appropriate chemical shift if the user asked for a residue
#and if the option for automatic positionning of the cursor was chosen


if {$cursorautopos && $askforresidue} {
			
	#check if the user simply wanted a proton chemical shift in a 2D
	#in that case $matchingDatasetPat=""
	
	if {$matchingDatasetPat!="" } {
	 
	#put the red cursor on the proton atom if there is only one possibility
	#and the black cursor on the other proton atom if there is one
	#but first check if there is assignnment for those protons
			
		
	if {[llength $childatomname]>0} {
				# at least one proton is assigned
				if {[nv_atom elem ppm [lindex $childatomname 0]]!=$string_for_no_shift_available} {
					cross2 [lindex $childatomname 0]
					if {$Nv_Priv(javaMode)} {
						puts "put the red cursor on [lindex $childatomname 0]"
					} else {
						puts "put the [[nv_win act] crosscolor 2] cursor on [lindex $childatomname 0]"
					}
				}
			
			
				if {[llength $childatomname]==2} {
					#a second proton is possible
					# check for assignment availability 
	
					if {[nv_atom elem ppm [lindex $childatomname 1]]!=$string_for_no_shift_available} {
						cross1 [lindex $childatomname 1]
						if {$Nv_Priv(javaMode)} {
							puts "put the black cursor on [lindex $childatomname 1]"
						} else {
							puts "put the [[nv_win act] crosscolor 1] cursor on [lindex $childatomname 1]"
						}
					}
				}
			} else {
			puts "There is no assignment for $originalrequest protons"
			puts "Cannot position the cursor"
		}
	
	} else {
		#The user asked for a proton (2D)
		cross2 $originalrequest	
	}
	
}


	if {$unitp==2} {
		#.nav.fra60.01.ent22 delete 0 end
		#.nav.fra60.01.ent22 insert 0 $originalrequest
		set curnumdisplayed $originalrequest
		# navigate in the nmrview Assign Panel 
		if { [winfo exists .assignPanel] && $navig_synchronize_asspanel} {
			set NvassignPanel(curres) [file rootname $originalrequest]
			NvUpdateAssignPan .assignPanel set 1
		}
	}




# return to the original window when done
nv_win act $originalwindow
if {!$Nv_Priv(javaMode)} {nav_wait off}

#end or procedure
}


####################################################
#Procedure used by NavigGoToPlane to get the protons
#names of a given N or C atom
#introduced in 5.1
####################################################
proc navig_getchildatomname {request} {
global navig_logan_parentlist
global string_for_no_shift_available

set childatomname ""
set restype  [nv_atom elem rname $request]
set resnumber [file root $request]
set atomtype [lindex [split $request .] 1]
set potential_childatomname [lrange [lindex $navig_logan_parentlist [lsearch $navig_logan_parentlist "$restype $atomtype\*"] ] 2 end]
	
foreach proton $potential_childatomname {
	#make sure there is chemical shift assignment, otherwise it won't be considered
	#for exemple, only one of the beta protons of a CB might be assigned
	if {[nv_atom elem ppm $resnumber.$proton]!=$string_for_no_shift_available} {
		set childatomname [concat $childatomname "$resnumber.$proton"]
	}
}

return $childatomname
#end of procedure navig_getchildatomname
}


####################################################
#General procedure that handles the change of planes
#
####################################################
proc DoTheChangeOfPlane {} {

global Nv_Priv
global unitp
global originalrequest originalrequest2 navigmultiplane

if {$unitp==0} {
	# plane units
	#have to do all of this because nmrviewJ does not understand nv_win pt
	
	if {$Nv_Priv(javaMode)} {
	
		set associated_dataset [nv_win dataset]
		#make num_of_planes not an integer
		set num_of_planes [expr [nv_dataset size $associated_dataset 3] + 0.0]
		set max_z_ppm [lindex [nv_win ppmMax z] 1]	
		set min_z_ppm [lindex [nv_win ppmMax z] 0]
		set m [expr ($min_z_ppm-$max_z_ppm)/($num_of_planes-1)]
		set b [expr $max_z_ppm-$m]
		
		set currentppm_z_sup [lindex [nv_win ppm z] 0]
		set currentppm_z_inf [lindex [nv_win ppm z] 1]
		
		set  planelimitsup [expr round(($currentppm_z_inf-$b)/$m)]
		set  planelimitinf [expr round(($currentppm_z_sup-$b)/$m)]
		
	} else {
		set planelimitinf [lindex [nv_win pt z] 0]
		set planelimitsup [lindex [nv_win pt z] 1]
	}
	
	
	#do a redraw only if needed
	if {!$navigmultiplane} {set originalrequest2 $originalrequest}
	if {$planelimitinf!=$originalrequest || $planelimitsup!=$originalrequest2} {
		
		if {$Nv_Priv(javaMode)} {
			set wannabe [expr $originalrequest*$m+$b]
			set wannabe2 [expr $originalrequest2*$m+$b]
			nv_win ppm z $wannabe $wannabe2;nv_win draw; update
			} else {
			nv_win pt z $originalrequest $originalrequest2;nv_win draw; update
		}
	}
	
} else {
	# ppm units or residue number
	# since v. 4.3, check if the spectral windows contains the destination plane or not, for faster display
	
	if {$unitp==2} {
		set destination [nv_atom elem ppm $originalrequest]
		set destination2 $destination
		
		} else {
		#units in ppm
		set destination  $originalrequest
		set destination2 $originalrequest2
		 
	}
	

	if {!$navigmultiplane || $unitp==2} {
		set originalrequest2 $originalrequest
		z $originalrequest 
	} else {
		nv_win ppm z $originalrequest $originalrequest2
		nv_win draw
		update
	}
		
		
}
}



####################################################################################
# Procedure to update the navigator window.  The procedure is called from within this 
# whole script and from within spectrum.tcl script.
####################################################################################

proc NavigUpdate {} {
	global Nv_Priv
	global curnumdisplayed
	global curnumdisplayed2
	global suppl1
	global suppl2
	global suppl3
	global suppl4
	global unitp
	global maxz
	global minz
	
#check if there is any spectrum window displayed
#the C version returns an error
#the Java version returns an empty string
set error [catch "nv_win dataset" class]
if {$error || [nv_win dataset]==""} {
	.nav.fra60.01.ent22 configure -text "N/A" 
	.nav.fra60.01.ent25 configure -text "N/A"
	.nav.fra60.01.lab23 configure -text ""
	.nav.fra60.01.lab24 configure -text ""
	.nav.fra60.01.lab26 configure -text ""
	.nav.fra60.01.lab27 configure -text ""
	return
}


set activedataset [nv_win dataset]

set numdim [nv_dataset ndim $activedataset]

set foldedz1 ""
set foldedz2 ""
set foldedz3 ""
set foldedz4 ""		
		
#check if it's a 3D or not.  If it's a 3D, need to calculate and display the folded chemical shifts
if {$numdim==3} {

	if {$unitp==0} {
		
		
		#temporary fix for the java version, which does not understand [nv_win pt z]
		if {$Nv_Priv(javaMode)} {
			set datasetsf [nv_dataset sf $activedataset 3]
			set datasetsw [nv_dataset sw $activedataset 3]
			set size [nv_dataset size $activedataset 3]
			set fold [expr $datasetsw/$datasetsf]
			#very important here: must consider the refpt
			set datasetcenter [nv_dataset ref  $activedataset 3]
			set datasetrefpt  [nv_dataset refpt $activedataset 3]
			set datasetsup [expr $datasetcenter+$fold/$size*($datasetrefpt-1)]
			set datasetinf [expr $datasetcenter-$fold/$size*($size-$datasetrefpt)]
			
			# ppm = plane#(m) + b
			set m [expr ($datasetinf-$datasetsup)/($size -1)]
			set b [expr $datasetsup - $m]
			
			set planerange ""
			foreach ppmvalue [nv_win ppm z] {append planerange "[expr round (($ppmvalue-$b)/($m))] "}
		} else { 
			set planerange [nv_win pt z]
		}
		
		set curnumdisplayed  [expr round([lindex $planerange 0])]
		set curnumdisplayed2 [expr round([lindex $planerange 1])]
	}

	if {$unitp==1} {
		set curnumdisplayed [format "%0.3f" [lindex [z] 1]]
		#add folded CS 
		set foldedz1 [format "%0.3f" [lindex [z] 2]]
		set foldedz2 [format "%0.3f" [lindex [z] 0]]
  	
		set foldedammount [expr [lindex [z] 0] - [lindex [z] 1]]
		set curnumdisplayed2 [format "%0.3f" [lindex [nv_win ppm z] 1]]
		set foldedz3 [format "%0.3f" [expr $curnumdisplayed2-$foldedammount]]
		set foldedz4 [format "%0.3f" [expr $curnumdisplayed2+$foldedammount]]

		}
}


if {$numdim==2} {set curnumdisplayed "It's a 2D"; set curnumdisplayed2 "It's a 2D"}
	
if {$unitp==2} {
	set curnumdisplayed ""
	set curnumdisplayed2 ""
	#disable the input box for multiplane mode
}

set suppl1 $foldedz1
set suppl2 $foldedz2
set suppl3 $foldedz3
set suppl4 $foldedz4

.nav.fra60.01.ent22 configure -textvariable curnumdisplayed
.nav.fra60.01.ent25 configure -textvariable curnumdisplayed2

.nav.fra60.01.lab23 configure -textvariable suppl1
.nav.fra60.01.lab24 configure -textvariable suppl2

.nav.fra60.01.lab26 configure -textvariable suppl3
.nav.fra60.01.lab27 configure -textvariable suppl4
}


###################################################################################
# procedure to find a peak list related to a dataset
###################################################################################

proc navig_get_relatedpeaklist {targetdatset} {

set answer ""
set allpeaklists [nv_peak list]
foreach potentialpeaklist $allpeaklists {
	if {[nv_peak dataset $potentialpeaklist]==$targetdatset} {set answer $potentialpeaklist; break}
}
return $answer
}


###################################################################################
#
# procedure to find out if there is a dataset displayed in the active window
#
###################################################################################
proc there_is_a_dataset_displayed {} {

global Nv_Priv
#The C and J version of nmrview have different behavior with nv_win dataset
#The C version returns an error if there is no dataset associated with the window
#The J version returns an empty string

set error [catch "nv_win dataset" class]
if {$error} {return 0} else {return 1}

}



##############################################################
#
# procedure to select which windows are going to be affected
#
##############################################################

proc WindowsAffectedBynNavig {} {
global Nv_Priv
global NvSpectrum
global onlyselfcheck
global allwin

set nameallwindows [nv_win open]
set selectwin ""
set activewin [nv_win act]
set basenameactivewin  [string range [string trimleft $activewin .] 0 [expr [string last . $activewin] -2]]
set pat  "?$basenameactivewin*"
set pat2 "\.peakId*"

#To make things simple, avoid issuing a command to the navigator if the active window does not have any dataset in it

if {![there_is_a_dataset_displayed]} {
	puts "Navigator>> You cannot issue a command to the navigator from a window that has no dataset"
	return
}


foreach item $nameallwindows {
	set error [catch "$item dataset" class]
	if {$error || [$item dataset]==""} {continue}
	
	#make sure there is a dataset associated with the window
	if {![there_is_a_dataset_displayed]} {continue}

	if {![string match $pat2 $item]} {
		if {[string match $pat $item] && $onlyselfcheck && ![string match $activewin $item]} {
		set selectwin [concat $selectwin $item]
		}
	
		if {![string match $pat $item] && $allwin} {
		set selectwin [concat $selectwin $item]
		}
	}
}

# finish by adding the original window.  This ensures that the original window will be
# the ending one (if it does have a dataset attached to it)
set selectwin [concat $selectwin $activewin]

return $selectwin
}



##############################################################################
#
# procedure that calculates the proper range of values to be displayed
# in the direct dimension
##############################################################################

proc navig_calc_directdimension_ppm_range {windowtochange directdimension_on_axis} {

global navig_peak_width_height_ratio

set currentdataset [nv_win dataset]
#check what the dimensions of the window are
set border_x [nv_win border x]
set border_y [nv_win border y]
set sum_border_x [expr [lindex $border_x 0] + [lindex $border_x 1]]
set sum_border_y [expr [lindex $border_y 0] + [lindex $border_y 1]]
set windowwidth  [expr [winfo width $windowtochange] - $sum_border_x]
set windowheight [expr [winfo height $windowtochange] -$sum_border_y]
set ppmxrange [expr abs([lindex [nv_win ppm x] 0]-[lindex [nv_win ppm x] 1])]
set ppmyrange [expr abs([lindex [nv_win ppm y] 0]-[lindex [nv_win ppm y] 1])]

if {$directdimension_on_axis=="x"} {
	set window_y_ppm_per_pixel [expr $windowheight/$ppmyrange]
	set range_x_needed_ppm [expr $navig_peak_width_height_ratio($currentdataset)*$windowwidth/$windowheight*$ppmyrange]
	set navigfocustightoffset [expr $range_x_needed_ppm/2]
}

if {$directdimension_on_axis=="y"} {
	set window_x_ppm_per_pixel [expr $windowwidth/$ppmxrange]
	set range_y_needed_ppm [expr $navig_peak_width_height_ratio($currentdataset)*$windowheight/$windowwidth*$ppmxrange]
	set navigfocustightoffset [expr $range_y_needed_ppm/2]
}

return $navigfocustightoffset

}

##############################################################
#
# procedure that responds to a selection in the history window
#
##############################################################

proc GoSelectionHistory {} {

global unitp curnumdisplayed comingfromhis navhistoryrecord navigmultiplane curnumdisplayed2

#set hisselection [selection get]
set curselection_number [.nav.fra62.cpd22.01 curselection]
if {$curselection_number==""} {return}
set hisselection [.nav.fra62.cpd22.01 get $curselection_number]


set hisselecttype [lindex $hisselection end]
switch -exact -- $hisselecttype {
	"(plane)"   {set unitp 0}
	"(ppm)"     {set unitp 1}
	"(residue)" {set unitp 2}
}

set curnumdisplayed [lindex $hisselection 0]
set comingfromhis 1
set navhistoryrecord 0


if {[string match "*to*" $hisselection]} {
	#history item with multiplane mode
	if {!$navigmultiplane} {changemultiplanemode}
	set curnumdisplayed2 [lindex $hisselection 2]
} else {
	#history item with no multiplane mode
	if {$navigmultiplane} {changemultiplanemode}
}

NavigGoToPlane


}


##############################################################
#
# procedure that expand/shrink the navigator window so one
# can see the history portion of it
#
##############################################################

proc NavHisViewExpandShrink {} {

global Nv_Priv navexpandheight navhistoryviewportion navigicondir

if {$Nv_Priv(javaMode)} {
	set iconextension "jpg"
	set iconformat JPG
	} else {
	set iconextension "gif"
	set iconformat GIF
}

set navigwindowupbutton [image create photo -format $iconformat -file "$navigicondir/navigwindowup.$iconextension"]
set navigwindowdownbutton [image create photo -format $iconformat -file "$navigicondir/navigwindowdown.$iconextension"]

if {$navhistoryviewportion=="hidden"} {
	# the window is shrunk, expand it
	wm geometry .nav 265x$navexpandheight
	set navhistoryviewportion "shown"
	.nav.fra61.but34 config -image $navigwindowupbutton
	
} else {
	# the window is expended, shrink it
	# save the current height for use when it will expand again
	set temp [wm geometry .nav]
	set navexpandheight [string range $temp [expr [string first x $temp] +1] [expr [string first + $temp] -1]]
	
	if {$Nv_Priv(javaMode)} {
		set currentbonds [lindex [.nav conf -bounds] end]
		set newheight [expr [lindex [.nav.fra60 config -height] end] + 130]
		set newdims [concat [lrange $currentbonds 0 2] $newheight]
		.nav conf -bounds $newdims
	
	} else {
		if {[string match *Aqua* [info nameofexecutable]]} {set addition 105} else {set addition 95}
		set newheight [expr [lindex [.nav.fra60 config -height] end] + $addition]
		wm geometry .nav 265x$newheight	
	}
	
	
	
	set navhistoryviewportion "hidden"
	.nav.fra61.but34 config -image $navigwindowdownbutton
}

}


##############################################################
#
# procedure that change the state of some button
#
##############################################################

proc ChangeNavigButton {target variable imagetodisplay} {

global onlyselfcheck allwin navhistoryrecord cursorautopos
global zoomrelated globalviewsave focustight
global navigzoomrelatedbutton_off navigselfonlybutton_off navigglobalviewbutton_off navighistoryrecordbutton_off navigcursorbutton_off navigfocustightbutton_off navigallotherwinbutton_off
global navigzoomrelatedbutton navigselfonlybutton navigglobalviewbutton navighistoryrecordbutton navigcursorbutton navigfocustightbutton navigallotherwinbutton


if {[eval "set $variable"]==0} {
	#button was off, activate it
	eval "set $variable 1"
	
	# stupid tcl stores image names as image_x, not by their names
	# must go case by case

	foreach item "$navigzoomrelatedbutton_off $navigselfonlybutton_off $navigglobalviewbutton_off $navighistoryrecordbutton_off $navigcursorbutton_off $navigfocustightbutton_off $navigallotherwinbutton_off" {
		if {[$target cget -image]==$item} {
			$target configure -image $imagetodisplay
			break
		}
	}
	eval "$target config -background darkred"

} else {

	#button was on, deactivate it
	set i -1
	set imglist "navigzoomrelatedbutton navigselfonlybutton navigglobalviewbutton navighistoryrecordbutton navigcursorbutton navigfocustightbutton navigallotherwinbutton"
	foreach item "$navigzoomrelatedbutton $navigselfonlybutton $navigglobalviewbutton $navighistoryrecordbutton $navigcursorbutton $navigfocustightbutton $navigallotherwinbutton" {
		incr i
		if {[$target cget -image]==$item} {
			set updateimg "$[lindex $imglist $i]\_off"
			eval "$target configure -image $updateimg"
			break
		}
	}

	eval "set $variable 0"
	eval "$target config -background #001e44"	
}
}

#end of procedure ChangeNavigButton



##############################################################
#
# procedure that saves views
#
##############################################################
proc NavigSaveView {args} {

global globalviewsave

set original_activewin [nv_win act]

set nameallwindows [nv_win open]

#filter out the ones that have no dataset attached
set nameallwindows_withdatasets ""
foreach item $nameallwindows {
	# have to filter out any window named .peakId
	if {[string match "\.peakId*" $item]} {continue}
	nv_win act $item
	if {[there_is_a_dataset_displayed]} {append nameallwindows_withdatasets "$item "}

}


nv_win act $original_activewin
set activewin $original_activewin


if {$globalviewsave || $args=="memory"} {
	set selectwin $nameallwindows_withdatasets
} else {
	set selectwin $activewin
}


set totalview ""

#now have to check the the existing limits for each windows and store the information
foreach item $selectwin {
	nv_win act $item
	set setting "{[nv_win name] [nv_win xdim] [nv_win ppm x] [nv_win ydim] [nv_win ppm y] [nv_win zdim] [nv_win ppm z] [nv_win lvl] [nv_win nlvl]}"
	set totalview [concat $totalview $setting]
}


#check if the view is to be added to the view list or to be saved in memory
if {$args=="viewlist"} {
	#add the name of the view in the list and store the info
	#with this format the user won't see all the info that goes with the view
	set linetoadd [format %-60s%10s [.nav.fra61.ent30 get] $totalview]
	.nav.fra63.cpd23.01 insert 0 $linetoadd
}

if {$args=="memory"} {
	return $totalview	
}



#end of procedure NavigSaveView
}


##############################################################
#
# procedure that restores views
#
##############################################################
proc NavigRestoreView {args} {

global globalviewsave
global navig_for_last_view

set currentactwin [nv_win act]
	
if {$args=="fromviewlist"} {
	if {[.nav.fra63.cpd23.01 curselection]==""} {return}
	#set nameviewselected [selection get]
	set curselection_number [.nav.fra63.cpd23.01 curselection]
	set nameviewselected [.nav.fra63.cpd23.01 get $curselection_number]
	set winset [lrange $nameviewselected 1 end] 
}

if {$args=="memory"} {
	if {$globalviewsave} {
		if {![info exists navig_for_last_view]} {
			# the user wants the last view but there is no such thing
			puts "no view yet in memory"
			return
		}
		set winset $navig_for_last_view
	} else {
		set winset [list [lindex $navig_for_last_view [lsearch $navig_for_last_view *$currentactwin*]]]
	}
}

foreach item $winset {
	set wintoact [lindex $item 0]
	if {[winfo exists $wintoact]} {
	nv_win act  $wintoact
	nv_win full
	nv_win xdim [lindex $item 1]
	nv_win ppm x [lindex $item 2] [lindex $item 3]
	nv_win ydim [lindex $item 4]
	nv_win ppm y [lindex $item 5] [lindex $item 6]
	nv_win zdim [lindex $item 7]
	nv_win ppm z [lindex $item 8] [lindex $item 9]
	nv_win lvl  [lindex $item 10]
	nv_win nlvl [lindex $item 11]
	nv_win draw
	} else {
		puts "Warning: window $wintoact does not exist anymore"
	}
}

# go back to the original active window
nv_win act $currentactwin
}

##############################################################
#
# procedure that changes the multiplane mode
#
##############################################################
proc changemultiplanemode {} {

global navigmultiplane navigmultimodeoffbutton navigmultimodeonbutton

if {$navigmultiplane} {
	#.nav.fra60.01.but50 configure -image $navigmultimodeonbutton
	set temp [wm geometry .nav]
	set currheight [string range $temp [expr [string first x $temp] +1] [expr [string first + $temp] -1]]		
	.nav.fra60 configure -height 50

	wm geometry .nav 265x[expr $currheight +24]
	set navigmultiplane 1


} else {
		#.nav.fra60.01.but50 configure -image $navigmultimodeoffbutton
		set temp [wm geometry .nav]
		set currheight [string range $temp [expr [string first x $temp] +1] [expr [string first + $temp] -1]]		
		.nav.fra60 configure -height 20
		wm geometry .nav 265x[expr $currheight -27]
		set navigmultiplane 0
}

}
 

##############################################################
#
# procedure to read views to disk
#
##############################################################
proc retrieveviewsfordisk {} {

global tk_version tk_strictMotif
set tk_strictMotif 0

set file [tk_getOpenFile -initialdir [pwd]]

if {$file!=""} {

	set viewsfile [open $file r]

	while {[gets $viewsfile line] != -1} {
        	.nav.fra63.cpd23.01 insert end [lindex $line 0]
 	}
    
  	close $viewsfile
}

}


##############################################################
#
# procedure to write views to disk
#
##############################################################
proc saveviewstodisk {} {

global tk_version tk_strictMotif
set tk_strictMotif 0

set file [tk_getSaveFile -initialdir [pwd]  -initialfile "navigatorviews"]

if {$file!=""} {
	set viewsfile [open $file w]

	for {set i 0} {$i<[.nav.fra63.cpd23.01 size]} {incr i} {
		puts $viewsfile [.nav.fra63.cpd23.01 get $i $i]
	}

	close $viewsfile
}

}

##############################################################
# procedure to determine if the spectrum needs zooming out
# on a given axis for a given string containing atoms
##############################################################
proc navig_check_zooming_needed {axis childatomname} {

set needszooming 0
set needredraw 0
set currentrange [nv_win ppm $axis]
set display_dim_max [navig_max $currentrange]
set display_dim_min [navig_min $currentrange]
							
foreach atom $childatomname {						
	set atomchemshift [nv_atom elem ppm $atom]
	if {$display_dim_max < $atomchemshift} {set display_dim_max [expr $atomchemshift+0.5];set needszooming 1}
	if {$display_dim_min > $atomchemshift} {set display_dim_min [expr $atomchemshift-0.5];set needszooming 1}
}

if {$needszooming} {
	nv_win ppm $axis $display_dim_max $display_dim_min
	set needredraw 1
}

return $needredraw
}


##############################################################
# procedure to determine the max value of a list
##############################################################
proc navig_max {list} {
    set max -1E10
    foreach item $list {
        if {$item > $max} then {
            set max $item
        }
    }   
    return $max
}  

##############################################################
# procedure to determine the min value of a list
##############################################################
proc navig_min {list} {
    set min 1E10
    foreach item $list {
        if {$item < $min} then {
            set min $item
        }
    }   
    return $min
}  


##############################################################
# procedure to determine the right x/y ratio
# for a given dataset according to the current spectral limits
##############################################################
proc navig_get_xyratio_display {} {

global navig_peak_width_height_ratio

#make sure there is a dataset displayed


	set currentwindow  [nv_win act]
	
	set border_x [nv_win border x]
	set border_y [nv_win border y]
	set sum_border_x [expr [lindex $border_x 0] + [lindex $border_x 1]]
	set sum_border_y [expr [lindex $border_y 0] + [lindex $border_y 1]]								
	set windowwidth  [expr [winfo width $currentwindow]  - $sum_border_x]
	set windowheight [expr [winfo height $currentwindow] - $sum_border_y]
	set ppmxrange [expr abs([lindex [nv_win ppm x] 0]-[lindex [nv_win ppm x] 1])]
	set ppmyrange [expr abs([lindex [nv_win ppm y] 0]-[lindex [nv_win ppm y] 1])]
								
	set windowwidth  [expr [winfo width  $currentwindow] -$sum_border_x]
	set windowheight [expr [winfo height $currentwindow] -$sum_border_y]	

	set currentdataset [nv_win dataset]
	set navig_peak_width_height_ratio($currentdataset) [expr $ppmxrange/$windowwidth/($ppmyrange/$windowheight)]
puts "navig_peak_width_height_ratio for $currentdataset set to $navig_peak_width_height_ratio($currentdataset)"

# end of proc navig_get_xyratio_display
}



##################################################################
#
# procedure to determine the right x/y ratio
# for a given dataset according to the current displayed peaklist
###################################################################
proc navig_get_xyratio_peaklist {peaklistdisplayed} {

global navig_peak_width_height_ratio

set datasetdisplayed [nv_win dataset]

if {$peaklistdisplayed=="none" || $peaklistdisplayed==""} {
	# there is no peak list associated with this window
	# try to find a peak list that has the current dataset in the window
	set allpeaklists [nv_peak list]
	foreach potentialpeaklist $allpeaklists {
		if {[nv_peak dataset $potentialpeaklist]==$datasetdisplayed} {set peaklistdisplayed $potentialpeaklist; break}
	} 
}

if {$peaklistdisplayed=="none" || $peaklistdisplayed==""} {
	# there was no peak list displayed, and no related peak list was found
	puts "Navigator >> There is no peak list displayed, and no peaklist related to the dataset $datasetdisplayed could be found in all the peak lists"
	puts "Navigator >> No x/y ration for the autozoom could be determined"
	return
}

	set peaklabels [nv_peak label $peaklistdisplayed]
	set namedim(1) [lindex $peaklabels 0]
	set namedim(2) [lindex $peaklabels 1]
	
	#find an average (peak width/peak height) ratio for the peaklist if it has never been calculated
	
	set numpeakused 0
	set sumratio 0
	foreachpeak i $peaklistdisplayed {
		#for some reason sometimes nmrview has a peak width and height of 0 for certain peaks
		set xwidth [nv_peak elem $namedim(1).W $peaklistdisplayed.$i]
		if {$xwidth>0} {
		set ywidth [nv_peak elem $namedim(2).W $peaklistdisplayed.$i]
		if {$ywidth>0} {
			incr numpeakused
			set sumratio [expr $sumratio + $xwidth/$ywidth]
			}
		}
	
	
	#nv_peak elem x.W and x.H report things in ppm units
	set navig_peak_width_height_ratio($datasetdisplayed) [expr $sumratio/$numpeakused]
	}

puts "navig_peak_width_height_ratio set to $navig_peak_width_height_ratio($datasetdisplayed) for the dataset $datasetdisplayed"

#end of proc navig_get_xyratio_peaklist					
}





###################################################
# procedure to calculate proper shift of a residue
# according to the sw in the z dimension
###################################################
proc navig_calculate_folded_shift {res_and_atom} {
	set limitz [nv_win ppmMax z]
	set maxz [navig_max $limitz]
	set minz [navig_min $limitz]
	set currentppm [nv_atom elem ppm $res_and_atom]


	while {$currentppm<$minz || $currentppm>$maxz} {
		# calculate the right value for that shift
		if {$currentppm > $maxz} {set currentppm [expr $minz-$maxz + $currentppm]}
		if {$currentppm < $minz} {set currentppm [expr $maxz-$minz + $currentppm]}
	}
	return $currentppm
}



 
################################################
#
# creation of the toplevel window "Navigator"
#
################################################

global Nv_Priv
global onlyselfcheck allwin navexpandheight navhistoryrecord
global zoomrelated globalviewsave cursorautopos navigicondir navhistoryviewportion
global navigmultiplane focustight
global navigfocustightoffset_default
global navig_logan_parentlist
global string_for_no_shift_available
global navig_synchronize_asspanel
global navigmultiplane navig_adjust_indirectdim

if {[winfo exist .nav]} {destroy .nav}

#set Java vs C specific variables
if {$Nv_Priv(javaMode)} {
	set iconextension "jpg"
	set iconformat JPG
	set titleextension J
	set string_for_no_shift_available ""
	set tk_macintosh_id "ppc"
	} else {
	set iconextension "gif"
	set iconformat GIF
	set titleextension C
	set string_for_no_shift_available "-1000000.000"
	set tk_macintosh_id "Power Macintosh"
}
 
  
set navigicondir [concat $Nv_Priv(imagedir)/navigicons]
set navigpreviousbutton      [image create photo -format $iconformat -file "$navigicondir/navigprevious.$iconextension"]
set naviggobutton            [image create photo -format $iconformat -file "$navigicondir/naviggo.$iconextension"]
set navigzoominbutton        [image create photo -format $iconformat -file "$navigicondir/navigzoomin.$iconextension"]
set navigzoomoutbutton       [image create photo -format $iconformat -file "$navigicondir/navigzoomout.$iconextension"]
set navigglobalviewbutton    [image create photo -format $iconformat -file "$navigicondir/navigglobalview.$iconextension"]
set navigallotherwinbutton   [image create photo -format $iconformat -file "$navigicondir/navigallotherwindows.$iconextension"]
set navighistoryrecordbutton [image create photo -format $iconformat -file "$navigicondir/navighistoryrecord.$iconextension"]
set navigwindowupbutton      [image create photo -format $iconformat -file "$navigicondir/navigwindowup.$iconextension"]
set navigwindowdownbutton    [image create photo -format $iconformat -file "$navigicondir/navigwindowdown.$iconextension"]
set navigselfonlybutton      [image create photo -format $iconformat -file "$navigicondir/navigselfonly.$iconextension"]
set navigzoomrelatedbutton   [image create photo -format $iconformat -file "$navigicondir/navigzoomrelated.$iconextension"]
set navigdeleteallbutton     [image create photo -format $iconformat -file "$navigicondir/navigdeleteall.$iconextension"]
set navigviewselectbutton    [image create photo -format $iconformat -file "$navigicondir/navigviewselect.$iconextension"]
set navigeraseitembutton     [image create photo -format $iconformat -file "$navigicondir/navigeraseitem.$iconextension"]
set navigcursorbutton        [image create photo -format $iconformat -file "$navigicondir/navigcursor.$iconextension"]
set navighistoryselectbutton [image create photo -format $iconformat -file "$navigicondir/navighistoryselect.$iconextension"]
set navigmultimodeoffbutton  [image create photo -format $iconformat -file "$navigicondir/navigmultimodeoff.$iconextension"]
set navigmultimodeonbutton   [image create photo -format $iconformat -file "$navigicondir/navigmultimodeon.$iconextension"]
set navigfocustightbutton    [image create photo -format $iconformat -file "$navigicondir/navigfocustight.$iconextension"]
set navigsaveviewbutton	     [image create photo -format $iconformat -file "$navigicondir/navigsaveviews.$iconextension"]
set navigretrieveviewbutton  [image create photo -format $iconformat -file "$navigicondir/navigviewfromdisk.$iconextension"]
set navigmenu				 [image create photo -format $iconformat -file "$navigicondir/navigmenu.$iconextension"]

set navigzoomrelatedbutton_off		[image create photo -format $iconformat -file "$navigicondir/navigzoomrelated_off.$iconextension"]
set navigselfonlybutton_off			[image create photo -format $iconformat -file "$navigicondir/navigselfonly_off.$iconextension"]
set navigglobalviewbutton_off		[image create photo -format $iconformat -file "$navigicondir/navigglobalview_off.$iconextension"]
set navighistoryrecordbutton_off 	[image create photo -format $iconformat -file "$navigicondir/navighistoryrecord_off.$iconextension"]
set navigcursorbutton_off			[image create photo -format $iconformat -file "$navigicondir/navigcursor_off.$iconextension"]
set navigfocustightbutton_off		[image create photo -format $iconformat -file "$navigicondir/navigfocustight_off.$iconextension"]
set navigallotherwinbutton_off		[image create photo -format $iconformat -file "$navigicondir/navigallotherwindows_off.$iconextension"]



set navig_logan_parentlist "{ALA N HN} {ALA CA HA} {ALA CB HB1 HB2 HB3 MB}  {CYS N HN} {CYS CA HA} {CYS CB HB1 HB2}  {ASP N HN} {ASP CA HA} {ASP CB HB1 HB2}  {GLU N HN} {GLU CA HA} {GLU CB HB1 HB2} {GLU CG HG1 HG2}  {PHE N HN} {PHE CA HA} {PHE CB HB1 HB2} {PHE CD1 HD1 HD2} {PHE CD2 HD1 HD2} {PHE CE1 HE1 HE2} {PHE CE2 HE1 HE2} {PHE CZ HZ}  {GLY N HN } {GLY CA HA1 HA2}  {HIS N HN } {HIS CA HA} {HIS CB HB1 HB2} {HIS ND1 HD1} {HIS CE1 HE1 HE2}  {ILE N HN} {ILE CA HA} {ILE CB HB} {ILE CG1 HG11 HG12} {ILE CG2 HG21 HG22 HG23 MG2} {ILE CD1 HD11 HD12 HD13 MD1}   {LYS N HN} {LYS CA HA} {LYS CB HB1 HB2} {LYS CG HG1  HG2} {LYS CD HD1 HD2} {LYS CE HE1 HE2}  {LEU N HN} {LEU CA HA} {LEU CB HB1 HB2} {LEU CG HG} {LEU CD1 HD11 HD12 HD13 MD1} {LEU CD2 HD21 HD22 HD23 MD2}  {MET N HN} {MET CA HA} {MET CB HB1 HB2} {MET CG HG1 HG2}  {MET CE HE1 HE2 HE3 ME}  {ASN N HN} {ASN CA HA} {ASN CB HB1 HB2} {ASN ND2 HD21 HD22}  {PRO CA HA} {PRO CB HB1 HB2} {PRO CG HG1 HG2} {PRO CD HD1 HD2}  {GLN N HN } {GLN CA HA} {GLN CB HB1 HB2} {GLN CG HG1 HG2} {GLN NE2 HE21 HE22}  {ARG N HN} {ARG CA HA} {ARG CB HB1 HB2} {ARG CG HG1 HG2} {ARG CD HD1 HD2} {ARG NH1 HH11 HH12} {ARG NE HE}  {SER N HN} {SER CA HA} {SER CB HB1 HB2}  {THR N HN} {THR CA HA} {THR CB HB} {THR CG2 HG21 HG22 HG23 MG2}  {VAL N HN} {VAL CA HA} {VAL CB HB} {VAL CG1 HG11 HG12 HG13 MG1} {VAL CG2 HG21  HG22 HG23 MG2}  {TRP N HN} {TRP CA HA} {TRP CB HB1 HB2} {TRP CD1 HD1} {TRP NE1 HE1} {TRP CZ2 HZ2} {TRP CH2 HH2} {TRP CZ3 HZ3} {TRP CE3 HE3}  {TYR N HN} {TYR CA HA} {TYR CB HB1 HB2} {TYR CD1 HD1 HD2} {TYR CD2 HD1 HD2} {TYR CE1 HE1 HE2} {TYR CE2 HE1 HE2}"





toplevel .nav
wm withdraw .nav
wm title .nav "Navigator 6.2 $titleextension"



################################################
#
# creation of the frames and other widgets
# for the interface
#
################################################

set base .nav

frame $base.fra60 \
         -borderwidth 0 -relief flat 
				 
frame $base.fra60.01 \
         -borderwidth 0 -relief flat 
				 
frame $base.fra70 \
        -borderwidth 2  -relief flat 
				 
frame $base.fra61 \
        -borderwidth 2  -relief flat				
				
frame $base.fra62 \
        -borderwidth 2 -relief groove 
				
frame $base.fra63 \
        -borderwidth 2 -relief groove  
	
frame $base.fra63.01 \
        -borderwidth 0 -relief flat 				
			
				
										
set base .nav.fra60.01

	entry $base.ent22 \
		-font {Helvetica -12} -textvariable curnumdisplayed  -width 6
    
	label $base.lab23 \
		-font {Helvetica -12}  -textvariable suppl1   -anchor center -width 6
    
	label $base.lab24 \
        -font {Helvetica -12}   -textvariable suppl2  -anchor center  -width 6
		
	entry $base.ent25 \
        -font {Helvetica -12} -textvariable curnumdisplayed2   -width 6
    
	label $base.lab26 \
        -font {Helvetica -12}  -textvariable suppl3   -anchor center -width 6
   
  label $base.lab27 \
        -font {Helvetica -12}   -textvariable suppl4  -anchor center -width 6
				
    
   menubutton $base.navoptions  -image  $navigmenu -menu $base.navoptions.menu -underline 0 -width 21 -height 21 -border 0 

	menu $base.navoptions.menu -tearoff 0
	$base.navoptions.menu add checkbutton -command {changemultiplanemode} -label "Multiplane mode" -variable navigmultiplane
	$base.navoptions.menu add checkbutton -command {} -label "Synchronize assignment panel" -variable navig_synchronize_asspanel
	
	menu $base.navoptions.menu.indsubmenu -tearoff 0
	$base.navoptions.menu add cascade -label "indirect dimension behavior (res mode)   " -menu $base.navoptions.menu.indsubmenu
	$base.navoptions.menu.indsubmenu add radiobutton -command {} -label "Do not change the display - keep as is" -variable navig_adjust_indirectdim -value 0

	$base.navoptions.menu.indsubmenu add radiobutton -command {} -label "Adjust to show the requested residue" -variable navig_adjust_indirectdim -value 1

	$base.navoptions.menu.indsubmenu add radiobutton -command {} -label "Set display limits according to related peaks" -variable navig_adjust_indirectdim -value 2

$base.navoptions.menu.indsubmenu add radiobutton -command {} -label "Set display limits to aliphatic region (up to 5.5 ppm)" -variable navig_adjust_indirectdim -value 3

$base.navoptions.menu.indsubmenu add radiobutton -command {} -label "Set display limits to amide region" -variable navig_adjust_indirectdim -value 4

$base.navoptions.menu.indsubmenu add radiobutton -command {} -label "Set display limits to first half" -variable navig_adjust_indirectdim -value 5

$base.navoptions.menu.indsubmenu add radiobutton -command {} -label "Set display limits to second half" -variable navig_adjust_indirectdim -value 6
	
$base.navoptions.menu.indsubmenu add radiobutton -command {} -label "Set display limits to maximum range" -variable navig_adjust_indirectdim -value 7
	
	if {!$Nv_Priv(javaMode)} {
		$base.navoptions.menu add separator
	} else {
		$base.navoptions.menu add command -command {} -label [string repeat _ 45]
	}
	
		
	$base.navoptions.menu add command -label "Set autozoom x/y ratio from display" -command {
			if {[nv_win open]!=""} {
				if {[there_is_a_dataset_displayed]} {
					navig_get_xyratio_display
				} else {
				    puts "Navigator>  there is no dataset associated with this window"
				} 
			} else {
				puts "Navigator>  there is no existing spectral window"
			}		
		} 
	
	
	$base.navoptions.menu add command -label "Set autozoom x/y ratio from peak list" -command {
				if {[nv_win open]!=""} {
					if {[there_is_a_dataset_displayed]} {
						navig_get_xyratio_peaklist [nv_win dispeaks]
					} else {
						puts "Navigator> there is no dataset displayed in this window"
					} 
				} else {
					puts "Navigator>  there is no existing spectral window"
				}
			}
			
			
if {!$Nv_Priv(javaMode)} {
		$base.navoptions.menu add separator
	} else {
		$base.navoptions.menu add command -command {} -label [string repeat _ 45]
	}


set navig_html_file "[string trimright  $Nv_Prefs(helpfile) index.html]/navigator_html/navigator_v6.htm"


if {$tcl_platform(machine)!=$tk_macintosh_id} {
        $base.navoptions.menu add command  -label "Help (external viewer)" -command "set helppid \[exec $Nv_Prefs(helpprogram) $navig_html_file &\]"
    } else {
    	#use Safari as external viewer. call it via applescript
       $base.navoptions.menu add command  -label "Help (using Safari)"  -command {osascript  -e "tell application \"Safari\"" -e "make new document at end of documents" -e "set url of document 1 to \"file://$navig_html_file\"" -e "end tell"}
    }     
     

$base.navoptions.menu add command -command {navig_about} -label "About NMRView's Navigator"	

	
	 
set base .nav.fra70
label $base.lab21 \
        -font {Helvetica -12} -text mode -anchor n
				
  radiobutton $base.rad26 \
        -command NavigUpdate -font {Helvetica -10 bold}  -text plane \
        -value 0 -variable unitp 
    radiobutton $base.rad27 \
        -command NavigUpdate -font {Helvetica -10 bold}  \
        -text ppm -value 1 -variable unitp 
    radiobutton $base.rad28 \
        -command NavigUpdate  -font {Helvetica -10 bold}  \
        -text residue -value 2 -variable unitp 


set base .nav.fra61

 	button $base.but25 \
        -activebackground yellow -command NavigGoToPlane  \
        -font {Helvetica -10}   -image $naviggobutton -border 2
	
   button $base.but29 \
        -activebackground yellow -command NavigZoom \
        -font {Helvetica -10 bold}   -image $navigzoominbutton -border 2
        
   button $base.but30 \
        -activebackground yellow -command NavigExpand \
        -font {Helvetica -10 bold}  -image $navigzoomoutbutton -border 2
        
   button $base.but31 \
        -activebackground yellow -command NavigPrevious \
        -font { Helvetica -10 bold}  -image $navigpreviousbutton -border 2
        

   button $base.but32 \
        -activebackground yellow  -background darkred -border 2\
				-command {ChangeNavigButton .nav.fra61.but32 onlyselfcheck $navigselfonlybutton} \
        -font { Helvetica -10 bold}  -image $navigselfonlybutton -anchor e -border 2
	
  button $base.but33 \
        -activebackground yellow  -background darkred -border 2 \
				-command {ChangeNavigButton .nav.fra61.but33 allwin $navigallotherwinbutton} \
        -font { Helvetica -10 bold}  -image $navigallotherwinbutton 
	
  button $base.but34 \
        -activebackground yellow   -font {Helvetica -10} -image $navigwindowdownbutton \
				-command {NavHisViewExpandShrink} -border 2
   
  button $base.but35 \
        -activebackground yellow  -background darkred -border 2 \
				-font {Helvetica -10} -image $navighistoryrecordbutton \
				-command {ChangeNavigButton .nav.fra61.but35 navhistoryrecord $navighistoryrecordbutton}  
	
	
  button $base.but36 \
        -activebackground yellow  -background darkred -border 2 \
				-font {Helvetica -10} -image $navigzoomrelatedbutton \
				-command {ChangeNavigButton .nav.fra61.but36 zoomrelated $navigzoomrelatedbutton}
	
  button $base.but37 \
        -activebackground yellow  -background darkred -border 2 \
				-font {Helvetica -10} -image $navigcursorbutton \
				-command {ChangeNavigButton .nav.fra61.but37 cursorautopos $navigcursorbutton}
  

  button $base.but38 \
        -activebackground yellow  -background darkred -border 2 \
				-font {Helvetica -10} -image $navigglobalviewbutton \
				-command {ChangeNavigButton .nav.fra61.but38 globalviewsave $navigglobalviewbutton}
	
  button $base.but39 \
 			 -activebackground yellow  -background darkred -border 2 \
				-font {Helvetica -10} -image $navigfocustightbutton \
				-command {ChangeNavigButton .nav.fra61.but39 focustight $navigfocustightbutton}
				
  entry $base.ent30 \
        -font {Helvetica -12} -textvariable viewnametosave -width 8


set base .nav.fra62
 
      frame $base.cpd22 \
        -borderwidth 1  -relief raised  
   
   
    if {$Nv_Priv(javaMode)} {
    	jscrollpane $base.cpd22.javascroll
    	$base.cpd22.javascroll configure -horizontalscrollbarpolicy [java::field javax.swing.JScrollPane HORIZONTAL_SCROLLBAR_NEVER]
	 	listbox $base.cpd22.01 -font {Helvetica -12} -height 3 -width 15
	 	$base.cpd22.javascroll add $base.cpd22.01
	 	grid $base.cpd22.javascroll \
        -in $base.cpd22 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
   
   } else {
        
    listbox $base.cpd22.01 \
        -font {Helvetica -12} \
        -yscrollcommand "$base.cpd22.02 set"  -height 3
   
    scrollbar $base.cpd22.02 \
        -command "$base.cpd22.01 yview" -width 10
    
    grid $base.cpd22.01 \
        -in $base.cpd22 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd22.02 \
        -in $base.cpd22 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -sticky ns 
    }
	
				
	button $base.but40 \
     -activebackground yellow -font {Helvetica -10}  -border 1 \
	-image $navigeraseitembutton \
    -command {.nav.fra62.cpd22.01 delete active} 
	
    button $base.but41 \
        -activebackground yellow -font {Helvetica -10} -border 1 \
	-image $navigdeleteallbutton \
	-command {.nav.fra62.cpd22.01 delete 0 end} 
	
    button $base.but42 \
  -activebackground yellow -font {Helvetica -10} -command {GoSelectionHistory} -border 1 \
	-image $navighistoryselectbutton


set base .nav.fra63
  
  frame $base.cpd23 \
        -borderwidth 1 -height 30 -relief raised 
   
  if {$Nv_Priv(javaMode)} {
    	jscrollpane $base.cpd23.javascroll
    	$base.cpd23.javascroll configure -horizontalscrollbarpolicy [java::field javax.swing.JScrollPane HORIZONTAL_SCROLLBAR_NEVER]
	 	listbox $base.cpd23.01 -font {Helvetica -12} -height 3 -width 15
	 	$base.cpd23.javascroll add $base.cpd23.01
	 	grid $base.cpd23.javascroll \
        -in $base.cpd23 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
   
   } else {
    listbox $base.cpd23.01 \
        -font {Helvetica -12} \
        -yscrollcommand "$base.cpd23.02 set" -height 3
    	scrollbar $base.cpd23.02 \
        -command "$base.cpd23.01 yview" -width 10
	grid $base.cpd23.01 \
        -in $base.cpd23 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd23.02 \
        -in $base.cpd23 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -sticky ns 
     }
				
set base .nav.fra63.01

	button $base.but60 \
        -activebackground yellow -font {Helvetica -10} -height 0 -border 1 \
		-image $navigeraseitembutton \
		-width 0 -command {.nav.fra63.cpd23.01 delete active} 
	
    button $base.but61 \
    	-activebackground yellow -font {Helvetica -10} -height 0 -border 1 \
		-image $navigdeleteallbutton \
		-width 0 -command {.nav.fra63.cpd23.01 delete 0 end} 
	
    button $base.but62 \
        -activebackground yellow -font {Helvetica -10} -command {NavigRestoreView fromviewlist} \
		-image $navigviewselectbutton -border 1
	
	 button $base.but63 \
        -activebackground yellow -font {Helvetica -10} -height 0  -border 1\
		-image $navigsaveviewbutton \
		-width 0 -command {saveviewstodisk} 
	

	button $base.but64 \
		-activebackground yellow -font {Helvetica -10} -height 0  -border 1\
		-image $navigretrieveviewbutton \
		-width 0 -command {retrieveviewsfordisk} 
	
      
	

pack .nav.fra60 \
      -in .nav -anchor center -expand 0 -fill x -side top 
			
place .nav.fra60.01 \
      -x 1 -y 1 -anchor nw
			#-in .nav.fra60 -anchor center -expand 0 -fill none -side top 		
			
set base .nav.fra60.01
	
  grid $base.ent22 \
        -in $base -column 0 -row 0 -columnspan 1 -rowspan 1   -ipadx 5
  grid $base.lab23 \
       -in $base -column 1 -row 0 -columnspan 1 -rowspan 1   -ipadx 10 
  grid $base.lab24 \
       -in $base -column 2 -row 0 -columnspan 1 -rowspan 1  -ipadx 5 
  #grid $base.but50 \
  #      -in $base -column 3 -row 0  -columnspan 2 -padx 15 
  
  grid  $base.navoptions \
       -in $base -column 3 -row 0  -columnspan 1 -padx 15 				
  

  grid $base.ent25 \
        -in $base -column 0 -row 1 -columnspan 1 -rowspan 1  -ipadx 5 -pady 2
  grid $base.lab26 \
       -in $base -column 1 -row 1 -columnspan 1 -rowspan 1 -ipadx 10 -pady 2
  grid $base.lab27 \
       -in $base -column 2 -row 1 -columnspan 1 -rowspan 1 -ipadx 5 -pady 2
				



pack .nav.fra70 \
      -in .nav  -anchor w -side top -expand 0 -fill x

set base .nav.fra70		

	grid $base.lab21 \
         -in $base -column 0 -row 0 -columnspan 1 -rowspan 1 -ipadx 5
				
	grid $base.rad26 \
         -in $base -column 1 -row 0 -columnspan 1 -rowspan 1 -ipadx 5
				 
	grid $base.rad27 \
         -in $base -column 2 -row 0 -columnspan 1 -rowspan 1 -ipadx 5
				 
	grid $base.rad28 \
         -in $base -column 3 -row 0 -columnspan 1 -rowspan 1 -ipadx 5
							

set base .nav.fra61	
			
	  grid $base.but25 \
        -in $base -column 0 -row 0 -columnspan 1 -rowspan 1 
		grid $base.but31 \
        -in $base -column 1 -row 0 -columnspan 1 -rowspan 1 
		grid $base.but32 \
        -in $base -column 2 -row 0 -columnspan 1 -rowspan 1 
		grid $base.but33 \
        -in $base -column 3 -row 0 -columnspan 1 -rowspan 1 
		grid $base.but35 \
        -in $base -column 4 -row 0 -columnspan 1 -rowspan 1 
		grid $base.but38 \
        -in $base -column 5 -row 0 -columnspan 1 -rowspan 1 
		grid $base.but34 \
        -in $base -column 6 -row 0 -columnspan 1 -rowspan 1 
		
		
		grid $base.but29 \
        -in $base -column 0 -row 1 -columnspan 1 -rowspan 1 
		grid $base.but30 \
        -in $base -column 1 -row 1 -columnspan 1 -rowspan 1 				
				
		grid $base.but36 \
        -in $base -column 2 -row 1 -columnspan 1 -rowspan 1 
		grid $base.but37 \
        -in $base -column 3 -row 1 -columnspan 1 -rowspan 1 
		grid $base.but39 \
        -in $base -column 4 -row 1 -columnspan 1 -rowspan 1 
		grid $base.ent30 \
	-in $base -column 5 -row 1 -columnspan 2 -rowspan 1 
				
pack .nav.fra61 \
      -in .nav -anchor w   -side top 		


pack .nav.fra62 \
         -in .nav  -anchor center -expand 1 -fill both -side top
				 
set base .nav.fra62	

  pack $base.but41 \
        -in $base -anchor center -expand 0 -fill none -side right 
    pack $base.but40 \
        -in $base -anchor center -expand 0 -fill none -side right 
    pack $base.but42 \
        -in $base -anchor center -expand 0 -fill none -side right 

	pack $base.cpd22 \
        -in $base -anchor center -expand 1 -fill both -side left  
    grid columnconf $base.cpd22 0 -weight 1
    grid rowconf $base.cpd22 0 -weight 1
#    grid $base.cpd22.01 \
        -in $base.cpd22 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
#    grid $base.cpd22.02 \
        -in $base.cpd22 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -sticky ns 
				
pack .nav.fra63 \
         -in .nav  -anchor center -expand 1 -fill both -side top
				 
set base .nav.fra63

pack .nav.fra63.01 \
         -in $base -anchor center -expand 0 -fill none -side right 
	 
set base .nav.fra63.01	 	

    grid $base.but62 \
        -in $base -column 0 -row 0 -columnspan 1 -rowspan 1 
    grid $base.but60 \
        -in $base -column 1 -row 0 -columnspan 1 -rowspan 1 
    grid $base.but61 \
         -in $base -column 2 -row 0 -columnspan 1 -rowspan 1 
    grid $base.but63 \
         -in $base -column 0 -row 1 -columnspan 1 -rowspan 1 
    grid $base.but64 \
         -in $base -column 1 -row 1 -columnspan 1 -rowspan 1 

set base .nav.fra63
    pack $base.cpd23 \
        -in $base -anchor center -expand 1 -fill both -side left 
    grid columnconf $base.cpd23 0 -weight 1
    grid rowconf $base.cpd23 0 -weight 1
   
     					
##################################################


.nav.fra60 config -height 20

.nav config -background #001e44
.nav.fra70 config -background #001e44
.nav.fra60 config -background #001e44 
.nav.fra61 config -background #001e44 
.nav.fra62 config -background #001e44
.nav.fra63 config -background #001e44
.nav.fra63.01 config -background #001e44


.nav.fra60.01 config -background #001e44				
.nav.fra60.01.ent22 config -background #001e44
.nav.fra60.01.ent22 config -foreground snow
.nav.fra60.01.ent22 config -highlightcolor snow

.nav.fra60.01.lab23 config -background #001e44
.nav.fra60.01.lab23 config -foreground  snow
.nav.fra60.01.lab24 config -background #001e44
.nav.fra60.01.lab24 config -foreground snow

.nav.fra60.01.ent25 config -background #001e44
.nav.fra60.01.ent25 config -foreground snow
.nav.fra60.01.ent25 config -highlightcolor snow

.nav.fra60.01.lab26 config -background #001e44
.nav.fra60.01.lab26 config -foreground  snow
.nav.fra60.01.lab27 config -background #001e44
.nav.fra60.01.lab27 config -foreground snow		

#.nav.fra60.01.navoptions conf -bg #001e44 
#.nav.fra60.01.navoptions conf -fg Yellow
#.nav.fra60.01.navoptions conf -activebackground Yellow

.nav.fra70.lab21 config -background #001e44
.nav.fra70.lab21 config -foreground yellow

.nav.fra70.rad26 config -background #001e44
.nav.fra70.rad26 config -foreground  snow
.nav.fra70.rad26 config -selectcolor yellow
.nav.fra70.rad26 config -highlightbackground #001e44
.nav.fra70.rad26 config -activebackground #001e44
.nav.fra70.rad26 config -activeforeground green

.nav.fra70.rad27 config -background #001e44
.nav.fra70.rad27 config -foreground  snow
.nav.fra70.rad27 config -selectcolor yellow
.nav.fra70.rad27 config -highlightbackground #001e44
.nav.fra70.rad27 config -activebackground #001e44
.nav.fra70.rad27 config -activeforeground green

.nav.fra70.rad28 config -background #001e44
.nav.fra70.rad28 config -foreground  snow
.nav.fra70.rad28 config -selectcolor yellow
.nav.fra70.rad28 config -highlightbackground #001e44

.nav.fra70.rad28 config -activebackground #001e44
.nav.fra70.rad28 config -activeforeground green


.nav.fra61.ent30 config -background #001e44
.nav.fra61.ent30 config -foreground snow

.nav.fra62.cpd22.01 config -background #b8cafe
.nav.fra63.cpd23.01 config -background #b8cafe

if {!$Nv_Priv(javaMode)} {
    .nav.fra62.cpd22.02 config -background #b8cafe
	.nav.fra63.cpd23.02 config -background #b8cafe  
}


# new since v. 5.01
# with NMRViewAqua the radio buttons text is always black
# too hard to see
# change the background of the radio buttons to another blue
if {[string match *Aqua* [info nameofexecutable]]} {
	.nav.fra70.rad26 conf -background #e0e4ff
	.nav.fra70.rad27 conf -background #e0e4ff
	.nav.fra70.rad28 conf -background #e0e4ff
}

# add some binding keys
    bind .nav.fra60.01.ent22 <Return> {NavigGoToPlane}
	bind .nav.fra60.01.ent25 <Return> {NavigGoToPlane}
    bind .nav.fra61.ent30 <Return> {NavigSaveView viewlist}
 
bind .nav.fra62.cpd22.01 <Double-ButtonRelease-1> {
    GoSelectionHistory
}

bind .nav.fra63.cpd23.01 <Double-ButtonRelease-1> {
    NavigRestoreView fromviewlist
}    
    
# make the cursor orange for the java version
if {$Nv_Priv(javaMode)} {
	.nav.fra60.01.ent22 configure -caretcolor orange
	.nav.fra60.01.ent25 configure -caretcolor orange
	.nav.fra61.ent30 configure -caretcolor orange
}

	
# add some balloon tips
add_tip .nav.fra61.but25 helpgo "Go to the selected plane, chemical shift, or residue."
add_tip .nav.fra61.but29 helpzoomin "Zoom in.  The target windows will depend on the options choosen"

add_tip .nav.fra61.but30 helpzoomout "Zoom out (full).  The target windows will depend on the options choosen"

add_tip .nav.fra61.but31 helpreviousview "Go to the previous view"
add_tip .nav.fra61.but32 helpselfonly "Option to apply Go to all spectra contained in the current spectrum window"
add_tip .nav.fra61.but33 helpotherwin "Option to apply Go and Zoom to all spectra in all windows"
add_tip .nav.fra61.but34 helpwinsize "Option to Expand or Shrink the navigator window to show the history and the view portion."

add_tip .nav.fra61.but35 helprecord "Option to Record or not the history."
add_tip .nav.fra61.but36 helpzoomrelated "Option to Zoom only to related spectra.  The relation of one spectrum to another is tested with the name of the axis labels."
add_tip .nav.fra61.but37 helpcursorautopos "Option to turn on cursor auto-positionning after requesting a residue chemical shift.  The red cursor will be positioned on the proton child of the requested atom chemical shift.  In case a C atom has two protons attached, the black cursor will be positioned on the 2nd one."
add_tip .nav.fra61.but38 helpglobalview "Option to store the current views of all spectra (global view).  When off, only the view settings of the active spectrum are saved"
add_tip .nav.fra61.but39 helptightfocus "Option to automatically zoom around peaks of requested residues"

add_tip .nav.fra70.rad26 helpplane "Turn into plane Mode.  The plane number will be indicated in the box above"
add_tip .nav.fra70.rad27 helpppm "Turn into ppm.Mode  Assuming TPPI, the possible chemical shifts will be indicated in the 3 field above"
add_tip .nav.fra70.rad28 helpres "Turn into resMode. Type res_numer.Cx or .Nx to access the plane corresponding to the given residue number and atom type"

add_tip .nav.fra60.01.ent22 helpgofield "Enter a plane number, a chemical shift or a residue number here.  Make sure the appropriate mode is selected below.  In case of a residue, also include an itom identifier, 128.CA for instance"

add_tip .nav.fra61.ent30 helpview "Save a view by entering a name for it, followed by return.  The view settings will be saved for the current spectrum, and if the globalview option is on, for all other spectra"

add_tip .nav.fra62.but40 helphiserase "Erase the current history item"
add_tip .nav.fra62.but41 helphistrash "Erase the whole history list"
add_tip .nav.fra62.but42 helphisselect "Select the current history item"

add_tip .nav.fra63.01.but60 helpviewerase "Erase the current view item"
add_tip .nav.fra63.01.but61 helpviewtrash "Erase the whole view list"
add_tip .nav.fra63.01.but62 helpviewselect "Select the current view item"
add_tip .nav.fra63.01.but63 helpviewtrash "Save the list of views on disk"
add_tip .nav.fra63.01.but64 helpviewtrash "Retrieve lists of views from disk"

#add_tip .nav.fra60.01.but50 helpmultiplanemode "Activate/Deactivate the multiplane mode"

 # some initiation variables
 set onlyselfcheck 1;
 set allwin 1;
 set navhistoryrecord 1;
 set zoomrelated 1;
 set globalviewsave 1;
 set cursorautopos 1;
 set navhistoryviewportion "hidden"
 set navexpandheight 325
 set comingfromhis 0
 set navigmultiplane 0 
 set focustight 01
 set navigfocustightoffset_default 0.2
 set unitp 0
 set navig_synchronize_asspanel 1
 set navig_adjust_indirectdim 2
	
###########################
# now show it all baby
###########################


if {$Nv_Priv(javaMode)} {
	set newdims "584 22 279 150"
	.nav conf -bounds $newdims

} else {
	if {[string match *Aqua* [info nameofexecutable]]} {set height 130} else {set height 118}
	wm geometry .nav 265x$height+650+22
}


#wm resizable .nav 0 1

#wm deiconify .nav
