 ############
 # Fontfix.tcl Version 1
 # Robert J. Mallis
 # 082201

 # for every window that is open
 # change the font as indicated for
 # the coordinates, axis labels, and
 # peak labels, respectively


 global Nv_coordfont
 global Nv_labelfont
 global Nv_peakfont

 set Nv_coordfont {Helvetica 12 normal}
 set Nv_labelfont {Helvetica 11 bold}
 set Nv_peakfont {Helvetica 10 normal}

 puts "Coordinate font (Nv_coordfont) is $Nv_coordfont"
 puts "Axis font (Nv_labelfont) is $Nv_labelfont"
 puts "Peak label font (Nv_peakfont) is $Nv_peakfont"

 proc Fontfix {} {
         global Nv_labelfont
         global Nv_coordfont
         global Nv_peakfont
         foreach i [win open] {
                 $i config -coordFont $Nv_coordfont
                 $i config -labelFont $Nv_labelfont
                 $i config -peakFont $Nv_peakfont
         }
 # print the selected fonts FYI

 puts "Coordinate font is $Nv_coordfont"
 puts "Axis font is $Nv_labelfont"
 puts "Peak label font is $Nv_peakfont"
 }
 ########

