#Script used to find symetry peaks
#Does a job like pipp by building up a peak list containing symetry peaks
# The red cursor is automatically put on the symetric peak chosen
# Written by Pascal Mercier
# April 23 1999
#
# v. 3.0 , written April 4 2000


proc Nv_ShowSymmetryWindow {} {

if {[winfo exists .symmetry]} {
        wm deiconify .symmetry
	} else {
	Nv_MakeSymmetry
   }

Sympeak


}


proc Nv_MakeSymmetry {} {

global errorfirstdim errorseconddim
################################################
#
# creation of the frames and other widgets
# for the interface
#
################################################

set base .symmetry
   toplevel $base -class Toplevel \
         -menu .symmetry.m32 
    wm focusmodel $base passive
    wm geometry $base 393x319+201+310
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Symmetric Peaks Panel"
    frame $base.fra18 \
        -borderwidth 2  -height 75 -width 125 
    label $base.fra18.lab23 \
        -borderwidth 1  -font {Helvetica -12 bold italic} \
        -relief flat -text {Symmetric peaks found} 
    frame $base.fra20 \
        -borderwidth 2  -height 75 -relief flat -width 125 
    frame $base.fra20.cpd25 \
        -borderwidth 1  -height 2 -relief raised -width 100 
    listbox $base.fra20.cpd25.01 \
         -font -sgi-screen-medium-*-normal-*-14-*-*-*-*-*-*-* \
        -xscrollcommand {.symmetry.fra20.cpd25.02 set} \
        -yscrollcommand {.symmetry.fra20.cpd25.03 set} 
    scrollbar $base.fra20.cpd25.02 \
        -borderwidth 1 -command {.symmetry.fra20.cpd25.01 xview} \
        -orient horizontal -width 10 
    scrollbar $base.fra20.cpd25.03 \
        -borderwidth 1 -command {.symmetry.fra20.cpd25.01 yview}  \
        -width 10 
    frame $base.fra22 \
        -borderwidth 2  -height 75 -relief flat -width 125 
    button $base.fra22.but28 \
        -activebackground #ecec4c  -padx 4 -pady 4 \
        -text {Clear List} -command ".symmetry.fra20.cpd25.01 delete 0 end" 
    button $base.fra22.but29 \
        -activebackground #ecec4c  -padx 4 -pady 4 -text Show -command "ShowSymPeak"
    button $base.fra22.but30 \
        -activebackground #ecec4c  -padx 4 -pady 4 -text Stay  -command "GoSymPeak"
    button $base.fra22.but31 \
        -activebackground #ecec4c  -padx 4 -pady 4 \
        -text Dismiss -command "cleanwindow;destroy $base"
    button $base.fra22.but32 \
        -activebackground #ecec4c  -padx 4 -pady 4 -text Recheck  -command "Sympeak"
    frame $base.fra21 \
        -borderwidth 2  -height 75 -relief flat -width 125 
    frame $base.fra21.cpd26 \
        -borderwidth 1  -height 30 -relief raised -width 30 
    label $base.fra21.cpd26.01 \
        -anchor w  -relief groove -text label \
        -textvariable namefirstdim 
    entry $base.fra21.cpd26.02 \
         -highlightthickness 0 -textvariable errorfirstdim \
         -width 10 
    frame $base.fra21.cpd27 \
        -borderwidth 1  -height 30 -relief raised -width 30 
    label $base.fra21.cpd27.01 \
        -anchor w -relief groove -text label -textvariable nameseconddim 
    entry $base.fra21.cpd27.02 \
         -highlightthickness 0 -textvariable errorseconddim \
         -width 10 
    menu $base.m32 \
        -cursor {} 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra18 \
        -in .symmetry -anchor center -expand 0 -fill none -side top 
    pack $base.fra18.lab23 \
        -in .symmetry.fra18 -anchor center -expand 0 -fill none -side top 
    pack $base.fra20 \
        -in .symmetry -anchor center -expand 1 -fill both -pady 5 -side top 
    pack $base.fra20.cpd25 \
        -in .symmetry.fra20 -anchor center -expand 1 -fill both -side top 
    grid columnconf $base.fra20.cpd25 0 -weight 1
    grid rowconf $base.fra20.cpd25 0 -weight 1
    grid $base.fra20.cpd25.01 \
        -in .symmetry.fra20.cpd25 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra20.cpd25.02 \
        -in .symmetry.fra20.cpd25 -column 0 -row 1 -columnspan 1 -rowspan 1 \
        -sticky ew 
    grid $base.fra20.cpd25.03 \
        -in .symmetry.fra20.cpd25 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -sticky ns 
    pack $base.fra22 \
        -in .symmetry -anchor center -expand 0 -fill none -pady 5 -side bottom 
    pack $base.fra22.but28 \
        -in .symmetry.fra22 -anchor center -expand 0 -fill none -padx 10 \
        -side left 
    pack $base.fra22.but29 \
        -in .symmetry.fra22 -anchor center -expand 0 -fill none -padx 10 \
        -side left 
    pack $base.fra22.but30 \
        -in .symmetry.fra22 -anchor center -expand 0 -fill none -padx 10 \
        -side left 
    pack $base.fra22.but32 \
        -in .symmetry.fra22 -anchor center -expand 0 -fill none -padx 10 \
        -side left 
    pack $base.fra22.but31 \
        -in .symmetry.fra22 -anchor center -expand 0 -fill none -padx 10 \
        -side left 

    pack $base.fra21 \
        -in .symmetry -anchor center -expand 0 -fill none -side bottom 
    pack $base.fra21.cpd26 \
        -in .symmetry.fra21 -anchor center -expand 0 -fill none -padx 20 \
        -side left 
    pack $base.fra21.cpd26.01 \
        -in .symmetry.fra21.cpd26 -anchor center -expand 0 -fill none -padx 2 \
        -pady 2 -side left 
    pack $base.fra21.cpd26.02 \
        -in .symmetry.fra21.cpd26 -anchor center -expand 1 -fill x -padx 2 \
        -pady 2 -side right 
    pack $base.fra21.cpd27 \
        -in .symmetry.fra21 -anchor center -expand 0 -fill none -padx 20 \
        -side right 
    pack $base.fra21.cpd27.01 \
        -in .symmetry.fra21.cpd27 -anchor center -expand 0 -fill none -padx 2 \
        -pady 2 -side left 
    pack $base.fra21.cpd27.02 \
        -in .symmetry.fra21.cpd27 -anchor center -expand 1 -fill x -padx 2 \
        -pady 2 -side right 


bind .symmetry.fra20.cpd25.01  <Double-1> {ShowSymPeak}
bind .symmetry.fra20.cpd25.01  <Return> {ShowSymPeak}


set errorfirstdim 0.05
set errorseconddim 0.05
}



proc Sympeak {} {
      

global firstplane coord1x coord1y namethirddim namefirstdim nameseconddim errorfirstdim errorseconddim

set errorfirstdim  [.symmetry.fra21.cpd26.02 get]
set errorseconddim [.symmetry.fra21.cpd27.02 get]
     set firstplane [nv_win z]
     set name_win [nv_win act]
     set coord1x [nv_win cross1x]
     set coord1y [nv_win cross1y]

set peaklist [nv_win dispeaks]

#check the name of the dimensions in the peak list
set namefirstdim  [lindex [nv_peak label $peaklist] 0]
set nameseconddim [lindex [nv_peak label $peaklist] 1]
set namethirddim  [lindex [nv_peak label $peaklist] 2]

set oldpeaktemplate [nv_peak template $peaklist]

#puts "nv_peak template $peaklist $namefirstdim $errorfirstdim $nameseconddim $errorseconddim"

 nv_peak template $peaklist $namefirstdim $errorfirstdim $nameseconddim $errorseconddim
 

 #before seaching for peaks, have to know what orientation the spectrum is in
 #check if it's reversed.  If it's not, assume the axis are in the same orientation
 # as when the peaks were picked

       if {[nv_win lab x]==$namefirstdim} {
       set f1 [nv_peak find $peaklist $coord1y $coord1x]
       puts "executing nv_peak find $peaklist $coord1y $coord1x"
       } else {
       set f1 [nv_peak find $peaklist $coord1x $coord1y]
       puts "executing nv_peak find $peaklist $coord1x $coord1y"
       }



 set f0 $peaklist.
    
     puts "Found [llength $f1] symmetric peaks"
    #loop to extract the peak numbers of the search result
     set i 0
     for {set i 1} {$i<=[llength $f1]} {incr i 1} {
     
     #the logical way to get the peak number would be to use
     #set peaknum [string trimleft [lindex $f1 [expr $i-1] ] $f0]
     # but there seems to be a bug in Tcl itself.

     set peaknum [string trimleft [string trimleft [lindex $f1 [expr $i-1] ] $peaklist] .]
     #get information about the peak (chemical shift) and assignement
     set sympeak1 [nv_peak elem $namefirstdim.P $peaklist.$peaknum]
     set sympeak2 [nv_peak elem $nameseconddim.P $peaklist.$peaknum]
     set assignedresidue [nv_peak elem $namethirddim.L $peaklist.$peaknum]
     if {$assignedresidue=="?"} {set assignedresidue "ND"}

     
     if {[nv_win lab x]==$namefirstdim} {
     set error1 [expr $sympeak1-$coord1y]
     set error2 [expr $sympeak2-$coord1x]
     } else {
     set error1 [expr $sympeak1-$coord1x]
     set error2 [expr $sympeak2-$coord1y]
     }
     set error3 [expr abs($error1) + abs ($error2)]
     set newline  [format "%-7s%6.2f%6.2f%8.2f%8.2f%8.2f%8s" $peaknum   $sympeak1   $sympeak2   $error1   $error2   $error3   $assignedresidue]

     .symmetry.fra20.cpd25.01 insert end $newline
     }
 if {$i!=1} {.symmetry.fra20.cpd25.01 insert end "---------------------------------------------------"}

nv_peak template $peaklist $oldpeaktemplate

}


proc ShowSymPeak {} {

global firstplane 
global coord1x
global coord1y
global namethirddim
global namefirstdim
global nameseconddim
cleanwindow 

set peakselect [lindex [selection get] 0]

#get the plane having the symetric peak chosen
set peaklist [nv_win dispeaks]
set plane [nv_peak elem $namethirddim.P $peaklist.$peakselect]
puts $plane

#turn in overlay mode and display the plane containing the chosen plane
nv_win aclear 0
nv_win z $plane
nv_win draw

#put the red cursor on the symetric peak
#set coord2x [nv_peak elem $namefirstdim.P $peaklist.$peakselect]
#set coord2y [nv_peak elem $nameseconddim.P $peaklist.$peakselect]
#puts $coord2x
#puts $coord2y
#nv_win cross2 $coord2x $coord2y

#put the red cursor on the swap coordinate of the original peak
nv_win cross2 $coord1y $coord1x
}

proc cleanwindow {} {
global firstplane
#turn in the non-overlay mode
nv_win aclear 1
nv_win z $firstplane
nv_win draw
}

proc GoSymPeak {} {
global coord1x
global coord1y
global namethirddim
global firstplane

nv_win aclear 1
set peakselect [lindex [selection get] 0]

#get the plane having the symetric peak chosen
set peaklist [nv_win dispeaks]
set plane [nv_peak elem $namethirddim.P $peaklist.$peakselect]
nv_win z $plane

#put the red cursor on the swap coordinate of the original peak
nv_win cross2 $coord1y $coord1x
nv_win draw
set firstplane [lindex [nv_win z] 0]
}
