# This procedure allows the user to search for peaks according to given chemical shifts
# Written by Pascal Mercier
# April 14, 2000
# v 1.0


proc searchpeaks {} {

if {![winfo exists .searchpeaks]} {
       makesearchpeaks
    } else {
     wm deiconify .searchpeaks
    }
}



proc  makesearchpeaks {} {

    set base .searchpeaks
      
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 620x294+52+158
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Search for peaks"

    menubutton $base.men18 \
        -background #AE00B200C300 -font {Helvetica -12} \
        -foreground #000000000000 -menu .searchpeaks.men18.m -padx 5 -pady 4 \
	-text Select -relief raised \
  
         
    label $base.lab19 \
        -borderwidth 1  -text {Peak list} 

    entry $base.ent10 \
        -font {Helvetica -12} \
        -foreground #000000000000 -textvariable .searchpeaks.men18.m(list)
          
    checkbutton $base.rad25 \
         -variable checkdim(1) -text ""
    checkbutton $base.rad26  \
         -variable checkdim(2) -text ""
    checkbutton $base.rad27 \
         -variable checkdim(3) -text "" 
    checkbutton $base.rad28 \
         -variable checkdim(4) -text ""
    entry $base.ent29 \
          -textvariable searchppm(1)
    entry $base.ent30 \
          -textvariable searchppm(2)
    entry $base.ent31 \
          -textvariable searchppm(3)
    entry $base.ent32 \
          -textvariable searchppm(4)
    frame $base.cpd34 \
        -borderwidth 1  -height 30 -relief raised -width 30 
    listbox $base.cpd34.01 \
        -font  -*-screen-medium-*-*-*-12-*-*-*-*-*-*-* \
        -xscrollcommand {.searchpeaks.cpd34.02 set} \
        -yscrollcommand {.searchpeaks.cpd34.03 set} 
    scrollbar $base.cpd34.02 \
        -borderwidth 1 -command {.searchpeaks.cpd34.01 xview} -orient horizontal \
        -width 10 
    scrollbar $base.cpd34.03 \
        -borderwidth 1 -command {.searchpeaks.cpd34.01 yview} -width 10 
    label $base.lab35 \
        -borderwidth 1  -text {Peaks found} 

 
    label $base.lab18 \
        -borderwidth 1 -text ppm 
    label $base.lab20 \
        -borderwidth 1 -text error 

   entry $base.ent20 \
          -textvariable errordim(1)
    entry $base.ent21 \
          -textvariable errordim(2)
    entry $base.ent22 \
          -textvariable errordim(3)
    entry $base.ent23 \
          -textvariable errordim(4)
    button $base.but24 \
         -activebackground #fe3640 -padx 11 -pady 4 -text {Clear List} -command {.searchpeaks.cpd34.01 delete 0 end}
    button $base.but25 \
          -activebackground #fe3640 -padx 11 -pady 4 -text Clear -command {.searchpeaks.cpd34.01 delete active}
    button $base.but26 \
          -activebackground #fe3640 -padx 11 -pady 4 -text Search -command {gosearchpeaks}

    button $base.but27 \
          -activebackground #fe3640 -padx 11 -pady 4 -text Go -command {Gochosenpeak}

    ###################
    # SETTING GEOMETRY
    ###################
    place $base.men18 \
        -x 215 -y 2 -width 46 -height 26 -anchor nw -bordermode ignore 
    place $base.lab19 \
        -x 5 -y 8 -width 55 -height 18 -anchor nw -bordermode ignore 
    place $base.ent10 \
        -x 65 -y 5 -width 145 -height 22 -anchor nw -bordermode ignore 
    place $base.rad25 \
        -x 10 -y 65 -anchor nw -bordermode ignore 
    place $base.rad26 \
        -x 10 -y 93 -anchor nw -bordermode ignore 
    place $base.rad27 \
        -x 10 -y 120 -anchor nw -bordermode ignore 
    place $base.rad28 \
        -x 10 -y 145  -anchor nw -bordermode ignore 
    place $base.ent29 \
        -x 75 -y 65 -width 48 -height 22 -anchor nw -bordermode ignore 
    place $base.ent30 \
        -x 75 -y 93 -width 48 -height 22 -anchor nw -bordermode ignore 
    place $base.ent31 \
        -x 75 -y 120 -width 48 -height 22 -anchor nw -bordermode ignore 
    place $base.ent32 \
        -x 75 -y 145 -width 48 -height 22 -anchor nw -bordermode ignore 
    place $base.cpd34 \
        -x 215 -y 55 -width 400 -height 225 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd34 0 -weight 1
    grid rowconf $base.cpd34 0 -weight 1
    grid $base.cpd34.01 \
        -in .searchpeaks.cpd34 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd34.02 \
        -in .searchpeaks.cpd34 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd34.03 \
        -in .searchpeaks.cpd34 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.lab35 \
        -x 290 -y 5 -anchor nw -bordermode ignore 
    place $base.but27 \
        -x 165 -y 255 -anchor nw -bordermode ignore 
    place $base.ent20 \
        -x 140 -y 65 -width 38 -height 22 -anchor nw -bordermode ignore 
    place $base.lab18 \
        -x 85 -y 40 -anchor nw -bordermode ignore 
    place $base.lab20 \
        -x 145 -y 40 -anchor nw -bordermode ignore 
    place $base.ent21 \
        -x 140 -y 93 -width 38 -height 22 -anchor nw -bordermode ignore 
    place $base.ent22 \
        -x 140 -y 120 -width 38 -height 22 -anchor nw -bordermode ignore 
    place $base.ent23 \
        -x 140 -y 145 -width 38 -height 22 -anchor nw -bordermode ignore 
    place $base.but24 \
        -x 10 -y 255 -anchor nw -bordermode ignore 
    place $base.but25 \
        -x 108 -y 255 -width 46 -height 28 -anchor nw -bordermode ignore 
    place $base.but26 \
        -x 10 -y 180 -width 175 -height 28 -anchor nw -bordermode ignore 
set menu .searchpeaks.men18.m
menu $menu -postcommand "NvFillPeakMenu $menu .searchpeaks.men18.m(list) {}  0"


bind .searchpeaks.ent10 <Return> {
	updatesearchforpeaks
}


bind .searchpeaks.men18.m <FocusOut> {
	updatesearchforpeaks
}


updatesearchforpeaks
}



proc updatesearchforpeaks {} {

global errordim labels

set currentpeaklist [.searchpeaks.ent10 get]
if {$currentpeaklist!="none"} {

	set labels [nv_peak label $currentpeaklist]
	set numlabels [llength $labels]
	for {set i 1} {$i<=$numlabels} {incr i} {
	.searchpeaks.rad[expr $i+24] configure -state normal
	}

	# set errors to current values in the template
	set currenttemplate [nv_peak template $currentpeaklist]
	
	set i 0
	foreach dimension $labels {
		incr i
		set j [lsearch $currenttemplate $dimension]
		if {$j!=-1} {
			set errordim($i) [string trimleft [lindex $currenttemplate [expr $j+1]] " "]
			.searchpeaks.rad[expr $i+24] select
			} else {
			set errordim($i) ""
			.searchpeaks.rad[expr $i+24] deselect
		}
	}
	
	
	# now label the check buttons according to the dimensions name
	set labels [nv_peak label $currentpeaklist]
	.searchpeaks.rad25 configure -text [lindex $labels 0]
	.searchpeaks.rad26 configure -text [lindex $labels 1]
	.searchpeaks.rad27 configure -text [lindex $labels 2]
	.searchpeaks.rad28 configure -text [lindex $labels 3]

	} else {
	for {set i 25} {$i<=28} {incr i} {

	.searchpeaks.rad$i configure -text ""
	.searchpeaks.rad$i deselect
	.searchpeaks.rad$i configure -state disabled
	}
	for {set i 1} {$i<=4} {incr i} {
		set errordim($i) ""
	}
}
}



###########################################
# procedure responding to Search button
###########################################
proc gosearchpeaks {} { 

global errordim checkdim labels currentpeaklist searchppm 

set currentpeaklist [.searchpeaks.ent10 get]
set numlabels [llength $labels]

# make the search template according to the dimensions chosen and the associated error range


set peaktemplate ""
set ppmlistsearch ""

set i 1

foreach dimension $labels {
	if {$checkdim($i)==1} {
		set peaktemplate [concat $peaktemplate $dimension $errordim($i)]
		set ppmlistsearch [concat $ppmlistsearch $searchppm($i)]
		}
	
	incr i
}

puts "the seach template is: $peaktemplate"

eval nv_peak template $currentpeaklist $peaktemplate 
set peaksfound [eval nv_peak find $currentpeaklist $ppmlistsearch]
puts "executing nv_peak find $currentpeaklist $ppmlistsearch"

for {set i 1} {$i<=$numlabels} {incr i} {
	set dimname($i) [lindex [nv_peak label $currentpeaklist] [expr $i-1]]
}


foreach peak $peaksfound {
	set peaknumber [string trimleft [string trimleft $peak $currentpeaklist] .]
	# get information about the peak
	for {set i 1} {$i<=$numlabels} {incr i} {
		set label($i)  [nv_peak elem $dimname($i).L $currentpeaklist.$peaknumber]
		set cshift($i) [nv_peak elem $dimname($i).P $currentpeaklist.$peaknumber]		
	}
	set result [format "%-4s" $peaknumber]
		
	for {set i 1} {$i<=$numlabels} {incr i} {set result $result[format "%8.2f" $cshift($i)]}
	for {set i 1} {$i<=$numlabels} {incr i} {set result $result[format "%8s" $label($i)]}
	#puts "$result"
	.searchpeaks.cpd34.01 insert end $result
 	
}
.searchpeaks.cpd34.01 insert end "-----------------------------------------------------"


}


###################################################################
# procedure responding to Go button
# the code is derived from the routine GoPeakPlane in peakanal.tcl
# (I'm too lazy to make a general macro)
###################################################################

proc Gochosenpeak {} {

global labels

set currentpeaklist [.searchpeaks.ent10 get]
set chosenpeak [lindex [.searchpeaks.cpd34.01 get active] 0]

set ndim [llength $labels] 

set name_win [nv_win act]

     set tl [winfo toplevel $name_win]
     set children [info commands $tl.*]
     
       foreach child $children {
        set error [catch "winfo class $child" class]
        if {$error} {continue}
        if {$class != "Spectrum" } {continue}

        nv_win active $child
        
        #check if the list is associated with the spectrum
          if {[nv_win dispeaks]==$currentpeaklist} {
           
        
             #check if it's a 3D expiment or not
             # important : assumes that z slices are displayed (2D of x,y)

                if {$ndim ==3} {
		set dim3peaklist [lindex [nv_peak label] 2]
                set zplane [nv_peak elem $dim3peaklist.P $currentpeaklist.$chosenpeak]       
                nv_win z $zplane
                nv_win draw
	        } 

              
              # check first if the peak is contained within the limit of the spectrum.  If not, make the window go full
	      
	     set dim1peaklist [lindex [nv_peak label] 0]
             set dim2peaklist [lindex [nv_peak label] 1]
	     set xmax [lindex [nv_win ppm x] 0]
	     set xmin [lindex [nv_win ppm x] 1]
             set ymin [lindex [nv_win ppm y] 0]
	     set ymax [lindex [nv_win ppm y] 1]
	
		#looks at the chemical shift in the x and y dimension

	     set CSdim1 [nv_peak elem $dim1peaklist.P $currentpeaklist.$chosenpeak]
	     set CSdim2 [nv_peak elem $dim2peaklist.P $currentpeaklist.$chosenpeak]

 	      	# check if the orientation of the spectum is the same as the peak list
	      if {[nv_win lab x]==$dim1peaklist} {
	       if {$CSdim1 > $xmax || $CSdim1 < $xmin || $CSdim2 > $ymax || $CSdim2 < $ymin} {
		nv_win full
		nv_win draw
		}

		} else {
		 if {$CSdim1 > $ymax || $CSdim1 < $ymin || $CSdim2 > $xmax || $CSdim2 < $xmin} {
		nv_win full
		nv_win draw
		}
	       }

	      #puts the black cursor on the the peak
	      # check if the orientation of the spectum is the same as the peak list

             if {[nv_win lab x]==$dim1peaklist} {
              nv_win cross1 [nv_peak elem $dim1peaklist.P $currentpeaklist.$chosenpeak] [nv_peak elem $dim2peaklist.P $currentpeaklist.$chosenpeak]
             } else {
              nv_win cross1 [nv_peak elem $dim2peaklist.P $currentpeaklist.$chosenpeak] [nv_peak elem $dim1peaklist.P $currentpeaklist.$chosenpeak]
             }
        }
   }
     nv_win active $name_win
 }
